<?php
/**
 * Emerald by MintJoomla
 * a component for Joomla! 1.7 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');
class EmeraldController extends JController
{
	function __construct()
	{

		if(!JRequest::getVar('view')) JRequest::setVar( 'view'  , 'plans');
		parent::__construct();
	}
	function display($cachable = false, $urlparams = false) {


		$this->_path['view'] = array(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_emerald'.DS.'views'.DS);

		$document   = JFactory::getDocument();
		$viewType	  = 'html';

		$viewName	  = JRequest::getCmd( 'view', 'plans' );
		$viewLayout	= JRequest::getCmd( 'layout', 'default' );
		EmeraldHelper::addSubmenu(JRequest::getCmd('view', 'plans'));

		$view = $this->getView( $viewName, $viewType, '', array( 'base_path'=>JPATH_ADMINISTRATOR.DS.'components'.DS.'com_emerald'));

		if ($model = $this->getModel($viewName)) {
			$view->setModel($model, true);
		}

		$view->setLayout($viewLayout);
		$view->display();
		//parent::display();
	}
	function edit()
	{
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();

		// Checkin the weblink
		$model = $this->getModel('plans');
		$model->checkout();
	}
	
	function publish()
	{
		global $app;

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to publish' ) );
		}

		$model = $this->getModel('plans');
		if(!$model->publish($cid, 1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		$this->setRedirect( 'index.php?option=com_emerald' );
		//parent::display();
	}


	function unpublish()
	{
		global $app;

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to unpublish' ) );
		}

		$model = $this->getModel('plans');
		if(!$model->publish($cid, 0)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_emerald' );
		//parent::display();
	}
	function orderup()
	{
		$model = $this->getModel('plans');
		$model->move(-1);

		$this->setRedirect( 'index.php?option=com_emerald');
	}

	function orderdown()
	{
		$model = $this->getModel('plans');
		$model->move(1);

		$this->setRedirect( 'index.php?option=com_emerald');
	}

	function saveorder()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		$model = $this->getModel('plans');
		$model->saveorder($cid, $order);

		$msg = 'New ordering saved';
		$this->setRedirect( 'index.php?option=com_emerald', $msg );
	}
	function save()
	{
		$post	= JRequest::get('post');
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post['id'] = (int) $cid[0];
		$db =  JFactory::getDBO();

		$sql = "SELECT * FROM #__jcs_plans WHERE id = ".$post['id'];
		$db->setQuery( $sql );
		$plan = $db->loadObject();

		$model = $this->getModel('plans');

		$dispatcher = JDispatcher::getInstance();
		JPluginHelper::importPlugin('system');
		$dispatcher->trigger('onAfterStoreSubscription',array( &$plan, &$model ) );

		if($post['days_type'] == 'years' && $post['days'] > 100)
		$post['days'] = 100;

		//print_r($post); return;
		if(@is_array(@$post['category']))
		{
			$post['category'] = implode(",", $post['category']);
			$post['type_category'] = 1;
		}
		if(@is_array($post['jsc_category']))
		{
			$post['contentcategory'] = implode(",", $post['jsc_category']);
			$post['type_category'] = 1;
		}
		if(@is_array(@$post['component']))
		{
			$post['type_component'] = 1;
			foreach($post['component'] AS $component)
			{
				$param1 = $post['task_'.$component];
				$param2 = $post['value_'.$component];

				$param_adv1 = $post['advtask_'.$component];
				$param_adv2 = $post['advcond_'.$component];
				$param_adv3 = $post['advvalue_'.$component];

				if($param1[0])
				{
					$post['params'][$component.'_task1'] = $param1[0];
					$post['params'][$component.'_val1'] = $param2[0];
				}
				if($param1[1])
				{
					$post['params'][$component.'_task2'] = $param1[1];
					$post['params'][$component.'_val2'] = $param2[1];
				}
				if($param1[2])
				{
					$post['params'][$component.'_task3'] = $param1[2];
					$post['params'][$component.'_val3'] = $param2[2];
				}
				if($param1[3])
				{
					$post['params'][$component.'_task4'] = $param1[3];
					$post['params'][$component.'_val4'] = $param2[3];
				}
				if(defined('EM_MODE') && EM_MODE)
				{
					if($param_adv1[0])
					{
						$post['params'][$component.'_advtask1'] = $param_adv1[0];
						$post['params'][$component.'_advcond1'] = $param_adv2[0];
						$post['params'][$component.'_advval1'] = $param_adv3[0];
					}
					if($param_adv1[1])
					{
						$post['params'][$component.'_advtask2'] = $param_adv1[1];
						$post['params'][$component.'_advcond2'] = $param_adv2[1];
						$post['params'][$component.'_advval2'] = $param_adv3[1];
					}

				}
			}
			$post['component'] = implode(",", $post['component']);
		}
		$post['params']['calculate_method'] = $post['method'];
		$post['params']['required'] = $post['required'];
		$post['params']['plans_grant'] = $post['grant_plans'];
		$post['params']['show_plans_grant'] = $post['show_grant'];
		$post['params']['karma'] = $post['karma'];
		$post['params']['karma_discount'] = $post['karma_discount'];
		$post['params']['redirect'] = $post['redirect'];
		$post['params']['cl_period'] = $post['cl_period'];
		$post['params']['currency'] = $post['currency'];
		$post['params']['layout_price'] = $post['layout_price'];
		$post['params']['extra_emails'] = $post['extra_emails'];
		$post['params']['date_from'] = $post['date_from'];
		$post['params']['date_to'] = $post['date_to'];
		$post['params']['plans_deactivate'] = $post['plans_deactivate'];
		$post['params']['discount_period'] = $post['discount_period'];
		
		$post['params']['muaccess'] = $post['muaccess'];
		if(isset($post['mua_msg_type']))
		{
			$post['params']['mua_msg_type'] = $post['mua_msg_type'];
		}

		if(@is_array(@$post['req_plans']))
		{
			$post['cross_plans'] = implode(",", $post['req_plans']);
		}			

		$post['params']['cp_plans'] = (@is_array(@$post['cp_plans'])) ? implode(",", $post['cp_plans']) : $post['cp_plans'];
		
		if($post['gid'] == 29) $post['gid'] = 0;
		if($post['gid'] == 30) $post['gid'] = 0;

		jimport('joomla.filter.filteroutput');
		$post['description'] = JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$post['finish_msg']  = JRequest::getVar( 'finish_msg', '', 'post', 'string', JREQUEST_ALLOWRAW );

		$post['msg_successful'] = JRequest::getVar( 'msg_successful', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$post['msg_fail']  = JRequest::getVar( 'msg_fail', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$post['msg_expiration'] = JRequest::getVar( 'msg_expiration', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$post['params']['send_as'] = JRequest::getVar( 'send_as');

		$post['adwords']  = JRequest::getVar( 'adwords', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$post['description'] = str_replace('<br>', '<br />', $post['description']);
		$post['finish_msg'] = str_replace('<br>', '<br />', $post['finish_msg']);

		$post['alerts']['msg_successful'] = str_replace('<br>', '<br />', $post['msg_successful']);
		$post['alerts']['msg_fail'] = str_replace('<br>', '<br />', $post['msg_fail']);
		$post['alerts']['msg_expiration'] = str_replace('<br>', '<br />', $post['msg_expiration']);
		$post['alerts']['msg_successful_sbj'] = $post['msg_successful_sbj'];
		$post['alerts']['msg_fail_sbj'] = $post['msg_fail_sbj'];
		$post['alerts']['msg_expiration_sbj'] = $post['msg_expiration_sbj'];

		$post['name']	= JFilterOutput::ampReplace($post['name']);


		$post['auto_child_plans'] = ($post['childs'] ? implode(',', $post['childs']) : '');
		$post['params']['auto_child_finish'] = $post['auto_child_finish'];
		$post['params']['auto_activate_in'] = $post['activate_in'];
		$post['params']['auto_activate_in_type'] = $post['activate_in_type'];

		$post['params']['alert_user'] = $post['alert_user'];
		$post['params']['purchase_limit'] = $post['purchase_limit'];
		$post['params']['count_limit_mode'] = $post['count_limit_mode'];


		$query = "SELECT title FROM #__usergroups WHERE id = " . (int) $post['gid'];
		
		$db->setQuery( $query );
		$usertype = $db->loadResult();
		$post['usertype'] = ($post['gid'] == 0) ? '' : $usertype;

		if ($model->store($post)) {
			$msg = JText::_( 'Subscription Plan Saved' );
		} else {
			$msg = JText::_( 'Error Saving Plan' );
		}

		// Check the table in so it can be edited.... we are done with it anyway
		$model->checkin();


		/*$registry = new JRegistry();
		$registry->loadArray($post['params']);
		$plugin_params  = $registry->toString();
		$plugin_params = new JRegistry($plugin_params);
		JPluginHelper::importPlugin('emerald');
		//$dispatcher->trigger('onCheckParams', array( $plugin_params ) );
		*/

		$link = 'index.php?option=com_emerald';
		if(JRequest::getWord('task') == 'apply' || count(JError::getErrors()) )
		$link = 'index.php?option=com_emerald&task=edit&cid[]='.$model->id;
		$this->setRedirect($link, $msg);
	}

	function remove()
	{
		global $app;

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to delete' ) );
		}

		$model = $this->getModel('plans');
		if(!$model->delete($cid)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_emerald' );
	}

	function cancel()
	{
		global $app;
		$id = JRequest::getVar('cid');
		$model = $this->getModel('plans');
		$model->checkin($id[0]);
		$this->setRedirect( 'index.php?option=com_emerald' );

	}

}
?>