<?php
/**
 * Emerald by MintJoomla
 * a component for Joomla! 1.7 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');
class EmeraldControllerCnf extends JController
{

	function __construct()
	{
		parent::__construct();
		$this->registerTask('apply', 'save');
		JRequest::setVar('view', 'cnf');
	}

	public function display($cachable = false, $urlparams = false)
	{
		JRequest::setVar('view', 'cnf');
		parent::display();
	}

	function apply()
	{
		$this->save();
	}

	function save()
	{
		global $app;
		
		$task = JRequest::getCmd('task');
		
		foreach($_POST['params'] as $var => $val)
		{
			if (is_array($val))
				$_POST['params'][$var] = serialize($val);
		}
		
		$params = new JParameter($_POST['params'], JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_emerald' . DS . 'params.xml');
		$params->bind($_POST['params']);
		$ini = $params->toString();
		
		JFile::write(JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_emerald' . DS . 'config.ini', $ini);
		
		$msg = JText::_('Successfully Saved Configuration');
		switch ($task)
		{
			case 'apply' :
				$app->redirect('index.php?option=com_emerald&controller=cnf', $msg);
				break;
			case 'save' :
			default :
				$app->redirect('index.php?option=com_emerald', $msg);
				break;
		}
	}

	function cancel()
	{
		global $app;
		$link = 'index.php?option=com_emerald';
		$app->redirect($link);
	}

	/*
	public function set($key, $value, $group = '_default')
	{
		global $JS_params_obj;
		
		if (!isset($JS_params_obj))
		{
			JError::raiseWarning(500, JText::_('Config controller is not initialised.'));
			return false;
		}
		
		$JS_params_obj->set($key, $value, $group);
		
		$ini = $JS_params_obj->toString();
		
		JFile::write(JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_emerald' . DS . 'config.ini', $ini);
		
		return true;
	}

	*/

	public static function initialyze()
	{
		
		$config = JComponentHelper::getParams('com_emerald');
		/*
		$uri = & JFactory::getURI();
		$ini = "";
		if (JFile::exists(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_emerald'.DS.'config.ini'))
		{
			$ini = JFile::read( JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_emerald'.DS.'config.ini' );
		}
		else if($ini=='')
		{
			return;
		}
		$config_params = new JRegistry( $ini, JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_emerald'.DS.'params.xml' );

		$GLOBALS[ 'JS_params_obj' ] = $config_params ;

		$params_array = $config_params->toArray();
		//print'<table>';
*/
		$params_array = $config->toArray();
		foreach($params_array as $key => $val)
		{
			$name = strtoupper('EM_' . $key);
			//print '<tr><td>'.strtoupper($name).'</td><td>'.$val.'</td></tr>';
			if (defined(strtoupper($name)))
			{
				continue;
			}
			
			define(strtoupper($name), $val, true);
		}
	
		//print'</table>';
	}
}
?>