<?php
/**
 * Emerald by MintJoomla
 * a component for Joomla! 1.7 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class EmeraldControllerCoupon extends EmeraldController
{
	function __construct()
	{
		parent::__construct();
		$this->registerTask('add', 'edit');
		$this->registerTask('apply', 'save');
	}

	function display()
	{
		JRequest::setVar('view', 'coupon');
		parent::display();
	}

	function publish()
	{
		global $app;

		JRequest::setVar('view', 'coupon');

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		$db = & JFactory::getDBO();
		$ids = implode(",", $cid);

		if (count( $ids ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to publish' ) );
		}

		$sql = "UPDATE #__jcs_coupons SET published = 1 WHERE id IN ($ids)";
		$db->setQuery($sql);
		$db->query();

		$this->setRedirect( 'index.php?option=com_emerald&view=coupon' );
		parent::display();
	}

	function unpublish()
	{
		global $app;

		JRequest::setVar('view', 'coupon');

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		$db = & JFactory::getDBO();
		$ids = implode(",", $cid);

		if (count( $ids ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to publish' ) );
		}

		$sql = "UPDATE #__jcs_coupons SET published = 0 WHERE id IN ($ids)";
		$db->setQuery($sql);
		$db->query();

		$this->setRedirect( 'index.php?option=com_emerald&view=coupon' );
		parent::display();
	}

	function remove()
	{
		global $app;

		JRequest::setVar('view', 'coupon');

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		$db = & JFactory::getDBO();
		$ids = implode(",", $cid);

		if (count( $ids ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to remove' ) );
		}

		$sql = "DELETE FROM #__jcs_coupons WHERE id IN ($ids)";
		$db->setQuery($sql);
		$db->query();

		$this->setRedirect( 'index.php?option=com_emerald&view=coupon' );
		parent::display();
	}


	function edit()
	{
		JRequest::setVar('view', 'coupon');
		JRequest::setVar('layout', 'form');
		JRequest::setVar('hidemainmenu', 1);
		parent::display();
	}

	function save()
	{
		JRequest::setVar('view', 'coupon');
		 
		$post	= JRequest::get('post');
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post['id'] = (int) $cid[0];
		 
		$model = $this->getModel('coupon', 'EmeraldModel');


		if ($model->store($post)) {
			$msg = JText::_( 'Coupon Saved' );
		} else {
			$msg = JText::_('Error Saving Coupon').'<br>'.$model->getError();
		}

		$model->checkin();

		$link = 'index.php?option=com_emerald&view=coupon';
		if(JRequest::getWord('task') == 'apply')
		$link = 'index.php?option=com_emerald&view=coupon&task=edit&cid[]='.$model->id;
		$this->setRedirect($link, $msg);
		parent::display();
	}
	
	function cancel()
	{
		// Checkin the weblink
		$model = $this->getModel('coupon');
		$model->checkin();

		$this->setRedirect( 'index.php?option=com_emerald&view=coupon' );
	}

}
?>
