<?php
/**
 * Emerald by MintJoomla
 * a component for Joomla! 1.7 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

class EmeraldControllerUsers extends EmeraldController
{
	function __construct()
	{
		parent::__construct();
		$this->registerTask( 'add', 'edit' );
		$this->registerTask( 'apply', 'save' );
		JRequest::setVar( 'view', 'users' );
	}
	function edit()
	{
		JRequest::setVar('view', 'users' );
		JRequest::setVar('layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();

		$model = $this->getModel('users');
		$model->checkout();
	}
	function save()
	{
		$post	= JRequest::get('post');
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post['id'] = (int) $cid[0];
		if(!$post['gateway_id'])
		$post['gateway_id'] = time();
		
		$model = $this->getModel('users');

		if ($model->store($post)) {
			$msg = JText::_( 'User Subscription Saved' );
				
			if($post['isNew'] == 1)
			{
				// creating grant plans
				$model->grantPlans($post);
			}
			if(!$post['id'])
			{
				EmeraldHelper::alertUser($post);
			}
		} else {
			$msg = JText::_( 'Error Saving User Subscription' );
		}

		// Check the table in so it can be edited.... we are done with it anyway
		$model->checkin();

		$link = 'index.php?option=com_emerald&view=users';
		if(JRequest::getWord('task') == 'apply')
		$link = 'index.php?option=com_emerald&view=users&task=edit&cid[]='.$model->id;
		$this->setRedirect($link, $msg);
	}
	function remove()
	{
		global $app;

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to delete' ) );
		}

		$model = $this->getModel('users');
		if(!$model->delete($cid)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_emerald&view=users' );
	}
	function publish()
	{
		global $app;

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to publish' ) );
		}

		$model = $this->getModel('users');
		if(!$model->publish($cid, 1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_emerald&view=users' );
	}
	function unpublish()
	{
		global $app;

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to unpublish' ) );
		}

		$model = $this->getModel('users');
		if(!$model->publish($cid, 0)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_emerald&view=users' );
	}
	function cancel()
	{
		// Checkin the weblink
		$model = $this->getModel('users');
		$model->checkin();

		$this->setRedirect( 'index.php?option=com_emerald&view=users' );
	}
}
?>
