<?php
/**
 * Emerald by MintJoomla
 * a component for Joomla! 1.7 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('JPATH_BASE') or die();

jimport('joomla.html.html');
jimport('joomla.form.formfield');

class JFormFieldEmSubscriptionPlanList extends JFormField
{
	protected $type = 'EmSubscriptionPlanList';

	protected function getInput()
	{
		if( !is_dir(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_emerald') ){
			return '<b>'.JText::sprintf('Component %sEmerald%s is not installed on your Joomla site',
			'<a href="http://www.mintjoomla.com">', '</a>').'</b>';
		}

		$value = $this->value;
		if( !is_array($value) ) {
			$value = array( $value );
		}
		$db = &JFactory::getDBO();

		$query = "SELECT sp.id AS value,
						 sp.name AS label, 
						 sp.catid, 
						 c.title AS cat_title
				    FROM #__jcs_plans  AS sp
			   		JOIN #__categories AS c ON c.id = sp.catid
			   	   WHERE sp.published = 1
				ORDER BY c.lft, c.id, sp.name";

		$db->setQuery($query);
		$plans = $db->loadObjectList();
		$options[] = JHTML::_('select.option', '-1', JText::_( 'All' ) );

		if( !$plans ) $plans = Array();
		$ccatid = '';
		if(count($plans))
		{
			for ($i = 0; $i< count($plans); $i ++)
			{
				$plan = $plans[$i];
				if ( $i > 0 && (intval($plan->catid) != intval($plans[$i-1]->catid) ))
				{
					if($i > 0)
					$options[] = JHTML::_('select.optgroup', $plans[$i-1]->cat_title );
					$options[] = JHTML::_('select.optgroup', $plan->cat_title );
				}
				$options[] = JHTML::_('select.option', $plan->value, $plan->label );

			}
		}

		if( count( $options ) >= 11 ) {
			$size = 11;
		} else {
			$size = count( $options );
		}
		return JHTML::_('select.genericlist',   $options,
		$this->name.'[]',
			'size="'.$size.'" multiple="multiple"', 
			'value', 'text', $value );
	}
}
?>
