<?php
/**
 * Emerald by MintJoomla
 * a component for Joomla! 1.7 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die;
define('FORM_SEPARATOR_NONE', 0);
define('FORM_SEPARATOR_SLIDER', 1);
define('FORM_SEPARATOR_FIELDSET', 2);
define('FORM_SEPARATOR_H2', 3);

define('FORM_STYLE_CLASSIC', 1);
define('FORM_STYLE_TABLE', 2);
define('FORM_STYLE_PARAMS', 3);
jimport('joomla.form.form');

class EmeraldHelper
{
	public static $extension = 'com_emerald';

	/**
	 * Configure the Linkbar.
	 *
	 * @param	string	$vName	The name of the active view.
	 *
	 * @return	void
	 * @since	1.6
	 */
	public static function addSubmenu($vName = 'plans')
	{
		JSubMenuHelper::addEntry(
			JText::_('Subscription plans'),
			'index.php?option=com_emerald&view=plans',
			$vName == 'plans'
			);
		JSubMenuHelper::addEntry(
			JText::_('User subscriptions'),
			'index.php?option=com_emerald&view=users',
			$vName == 'users');
		JSubMenuHelper::addEntry(
			JText::_('Plan category'),
			'index.php?option=com_categories&extension=com_emerald',
			$vName == 'categories'		
			);
			
		if ($vName=='categories') {
			JToolBarHelper::title(
				JText::sprintf('COM_CATEGORIES_CATEGORIES_TITLE',JText::_('com_emerald')),
				'plan-categories');
		}
		JSubMenuHelper::addEntry(
			JText::_('Coupons'),
			'index.php?option=com_emerald&view=coupon',
			$vName == 'coupons'
			);
		JSubMenuHelper::addEntry(
			JText::_('Payment Plugins'),
			'index.php?option=com_plugins&filter_folder=emerald',
			$vName == 'paymment_plug'		
			);
		JSubMenuHelper::addEntry(
			JText::_('About'),
			'index.php?option=com_emerald&view=plans&layout=about'
		);
	}
	
function alertUser($post, $admin = 0)
	{
		global $app;
		$user = JFactory::getUser($post['user_id']);
		$db = & JFactory::getDBO();

		$sid = $post['sid'] ? $post['sid'] : $post['subscription_id'];
		$sql = "SELECT name, params, alerts FROM #__jcs_plans WHERE id = '$sid'";
		$db->setQuery($sql);
		$res = $db->loadObject();
		$name = $res->name;
		$params = new JRegistry($res->params);
		$config = JFactory::getConfig();
		$alerts = new JRegistry($res->alerts);
		jimport('joomla.mail.mail');

		//$mail = new JMail();
		$mail = JFactory::getMailer();

		$sender[0] = $config->getValue('config.mailfrom');
		$sender[1] = $config->getValue('config.fromname');

		if($params->get('alert_user', 1))
		{

			if($post['published'] == 1 || $post['pay'] == 'success')
			{
				$body = JText::_($alerts->get('msg_successful', "GENERAL_ALERT_SUCCESS"));
				$subject = JText::_($alerts->get('msg_successful_sbj', 'Your Subscription created successfully'));
			}
			else
			{
				$body = JText::_($alerts->get('msg_fail', "GENERAL_ALERT_FAIL"));
				$subject = JText::_($alerts->get('msg_fail_sbj', 'Your Subscription created but not activated'));
			}

			$jf_file = JPATH_BASE.DS.'components'.DS.'com_joomfish'.DS.'joomfish.php';
			if(file_exists($jf_file))
			{
				$lang = $config->getValue('config.jflang');
				$sql = "SELECT jf.value FROM #__jf_content jf
				JOIN #__languages l ON l.id = jf.language_id
				WHERE l.code='$lang'
				AND jf.reference_table = 'emerald_plans' AND jf.reference_field = 'alerts' AND jf.published = '1' AND jf.reference_id = '$sid'";
				$db->setQuery($sql);
				if($res = $db->loadResult())
				{
					$jfparams = new JRegistry($res);

					if($post['published'] == 1 || $post['pay'] == 'success')
					$body = $jfparams->get('msg_successful');
					else
					$body = $jfparams->get('msg_fail');

				}
			}

			$body = str_replace('[USER]', str_replace("\n", " ", $user->get('name')), $body);
			$body = str_replace('[FIRST_NAME]', str_replace("\n", " ", $user->get('name')),$body);
			$body = str_replace('[SUBSCR_NAME]', '"'.$name.'"', $body);
			$body = str_replace('[SITE_NAME]', $app->getCfg('sitename'), $body);
			$body = str_replace('[SITE_URL]', JURI::root(), $body);
			$body = str_replace('[ORDER_ID]', $post['gateway_id'], $body);
			if(isset($post['transact'])){
				$body = str_replace('[TRANSACT]', $post['transact'], $body);
			}
			$body = str_replace('[PRICE]', str_replace(array("00", "Sign") , array($post['price'], EM_GENERAL_CURR), EM_LAYOUT_PRICE), $body);
			$body = str_replace('[DATE]', date("M j, Y"), $body);
			$body = str_replace('[TIME]',  date("G:i:s"), $body);

			if($params->get('send_as', 'text') == 'text') $body = strip_tags(str_replace("<br />", "\n", $body));

			$mail->setSender($sender);
			$mail->AddAddress($user->get('email'));
			$mail->setBody(JMailHelper::cleanBody($body));
			$mail->setSubject(JMailHelper::cleanSubject($subject));

			if ( JString::strlen($body) != JString::strlen(strip_tags($body)))
			{
				$mail->IsHTML(true);
			}

			if(!$mail->Send())
			{
				JError::raiseWarning(200, 'Error to send user alert');
			}
		}
		if($admin)
		{
			$subject = JText::_('New Subscription Alert').": [".( ($post['pay'] == 'success') ? JText::_('Success') : JText::_('Fail'))."] [{$name}]";

			$body = $alerts->get('msg_admin', JText::_("GENERAL_ALERT_ADMIN"));
			$body = str_replace('[USER]', str_replace("\n", " ", $user->get('name')),$body);
			$body = str_replace('[FIRST_NAME]', str_replace("\n", " ", $user->get('name')),$body);
			$body = str_replace('[SUBSCR_NAME]', '"'.$name.'"', $body);
			$body = str_replace('[SITE_NAME]', $app->getCfg('sitename'), $body);
			$body = str_replace('[ORDER_ID]', $post['gateway_id'], $body);
			$body = str_replace('[SITE_URL]', JURI::root()."administrator", $body);
			$body = str_replace('[EMAIL]', $user->get('email'),$body);
			$body = str_replace('[PRICE]', str_replace(array("00", "Sign") , array($post['price'], EM_GENERAL_CURR), EM_LAYOUT_PRICE), $body);
			$body = str_replace('[DATE]', date("M j, Y", $post['gateway_id']), $body);
			$body = str_replace('[TIME]',  date("G:i:s", $post['gateway_id']), $body);

			$sql = "SELECT d.fvalue, f.alias FROM #__juser_extended_fields f
			JOIN #__juser_extended_data d ON d.field_id=f.id WHERE d.user_id='".$user->id."'";
			$db->setQuery($sql);
			if($juser = $db->loadObjectList())
			{
				foreach($juser as $data)
				{
					$body = str_replace('['.strtoupper($data->alias).']', $data->fvalue, $body);
				}
			}

			if($params->get('send_as', 'text') == 'text') $body = strip_tags(str_replace("<br />", "\n", $body));

			$mail->ClearAllRecipients();

			$mail->AddAddress($sender[0]);

			if($extra_emails = $params->get('extra_emails'))
			{
				$extra_emails = str_replace(', ', ',', $extra_emails);
				$extra_emails = explode(',', $extra_emails);
				$mail->AddCC($extra_emails);
			}
			$mail->setBody(JMailHelper::cleanBody($body));
			$mail->setSubject(JMailHelper::cleanSubject($subject));
			if ( JString::strlen($body) != JString::strlen(strip_tags($body)))
			{
				$mail->IsHTML(true);
			}

			if(!$mail->Send())
			{
				JError::raiseWarning(200, 'Error to send admin alert');
			}
		}
	}
	
}



class EMFormHelper extends JForm
{

	function __construct()
	{
		$this->option = JRequest::getVar('option');
	}

	static public function checkExtension($ext)
	{
		$result = NULL;
		
		if(! JFolder::exists(JPATH_ADMINISTRATOR . DS . 'components' . DS . $ext))
		{
			switch($ext)
			{
				case 'com_mightytouch':
					$result = 'Please install <b>Mighty Touch</b> extensions';
				break;
				case '':
				break;
				case '':
				break;
				default:
					$result = 'Please install <b>' . $ext . '</b> extensions';
			}
		}
		
		return JText::_($result);
	}

	static public function renderGroups($form, $groups, $defaults)
	{
		settype($groups, 'array');
		
		$out = JHtml::_('sliders.start', 'type-sliders', array(
			'useCookie' => 1
		));
		
		foreach($groups as $group => $group_name)
		{
			$out_group = self::renderGroup($form, $defaults, $group);
			if($out_group != '')
			{
				$out .= JHtml::_('sliders.panel', $group_name, $group);
				$out .= $out_group;
			}
		}
		
		$out .= JHtml::_('sliders.end');
		
		return $out;
	}

	static public function renderGroup($form, $defaults, $group)
	{
		$fieldsets = $form->getFieldsets($group);
		$out = '';
		foreach($fieldsets as $name => $fieldset)
		{
			$out .= "<h2 style=\"padding-left:20px; margin-bottom:2px;\">" . JText::_($fieldset->label) . "</h2>";
			$out .= self::renderFieldset($form, $name, $defaults, $group, 2, 0);
		}
		return $out;
	}

	static public function renderForm($form, $defaults, $group = null, $separator = 0, $style = 1)
	{
		$fieldsets = $form->getFieldsets($group);
		
		$out = '';
		if($separator == FORM_SEPARATOR_SLIDER)
		{
			$pane = JPane::getInstance('Sliders');
			$out .= JHtml::_('sliders.start', 'type-sliders', array(
				'useCookie' => 1
			));
		}
		foreach($fieldsets as $name => $fieldset)
		{
			switch($separator)
			{
				case FORM_SEPARATOR_H2:
					$out .= "<h2 style=\"padding-left:20px;\">" . JText::_($fieldset->label) . "</h2>";
				break;
				case FORM_SEPARATOR_FIELDSET:
					$out .= sprintf('<fieldset><legend>%s</legend>', JText::_($fieldset->label));
				break;
				
				case FORM_SEPARATOR_SLIDER:
					$out .= JHtml::_('sliders.panel', JText::_($fieldset->label), $fieldset->name);
				break;
			}
			$out .= self::renderFieldset($form, $name, $defaults, $group, $style, 0);
			switch($separator)
			{
				case FORM_SEPARATOR_FIELDSET:
					$out .= '</fieldset>';
				break;
				
				case FORM_SEPARATOR_SLIDER:
				//$out .= JHtml::_('sliders.end');
				break;
			}
		}
		
		if($separator == FORM_SEPARATOR_SLIDER)
		{
			$out .= JHtml::_('sliders.end');
		}
		
		return $out;
	}

	/**
	 * 
	 * @param JForm $form form object
	 * @param string $name name of the fieldset
	 * @param string $group name of the group
	 * @param string $type may be classic, table, params
	 * @return string Raw HTML text 
	 */
	static public function renderFieldset($form, $name, $defaults, $group = null, $type = 1, $title = 1)
	{
		$fieldsets = $form->getFieldsets($group);
		$fieldset = $fieldsets[$name];
		
		if(is_array($defaults))
		{
			$registry = new JRegistry();
			$registry->loadArray($defaults);
			$defaults = $registry;
		}
		/*else if(is_string($item->params))
		{
			$registry = new JRegistry;
			$registry->loadString($item->params);
			$defaults = $registry;
		}*/
		
		$fields = $form->getFieldset($name);
		$defaultGetName = empty($group) ? '%2$s' : '%s.%s';
		$doc = JFactory::getDocument();
		$doc->addStyleSheet(JURI::root() . 'libraries/mint/forms/style.css');
		$out = '';
		switch($type)
		{
			case 1:
				if($title)
				{
					$out .= '<fieldset class="adminform whitebg"><legend>' . JText::_($fieldset->label) . '</legend>';
				}
				if(isset($fieldset->description) && ! empty($fieldset->description)) $out .= '<small class="small">' . JText::_($fieldset->description) . '</small>';
				$out .= '<ul class="adminformlist">';
				foreach($fields as $key => $field)
				{
					$out .= '<li>';
					if(! $field->hidden)
					{
						$out .= $field->label;
					}
					$out .= $form->getInput($field->fieldname, $group, $defaults->get(sprintf($defaultGetName, $group, $field->fieldname)));
					$out .= '</li>';
				}
				$out .= '</ul>';
				if($title) $out .= '</fieldset>';
			break;
			
			case 2:
				if($title) $out .= '<h2 class="params-title">' . JText::_($fieldset->label) . '</h2>';
				if(isset($fieldset->description) && ! empty($fieldset->description)) $out .= '<span class="small" style="padding-left:20px;display:block;">' . JText::_($fieldset->description) . '</span>';
				$out .= '<table class="adminlist">';
				$i = 1;
				$hidden = array();
				foreach($fields as $key => $field)
				{
					if($field->hidden)
					{
						$hidden[] = $field;
						continue;
					}
					if($field->type == 'Caddress' || $field->type == 'Ccontacts' || $field->type == 'Clinks')
					{
						$out .= '</table>';
						//$out .= '<tr class="row'.$i = 1 - $i.'"><td colspan="2">';
						$out .= '<h2 style="padding-left:20px;">' . $field->label . '</h2>';
						$out .= '<br />';
						$out .= $form->getInput($field->fieldname, $group, $defaults->get(sprintf($defaultGetName, $group, $field->fieldname)));
						//$out .= '</td></tr>';
						$out .= '<br /><table class="adminlist">';
					}
					else
					{
						//JForm
						//FieldRadio
						//JXMLElement
						//$fieldo = ;
						$out .= '<tr class="row' . $i = 1 - $i . '"><td class="key" nowrap="nowrap">';
						//$out .= $field->class;
						//$out .= $form->getFieldAttribute($field->fieldname, 'class');
						$out .= $field->label;
						$out .= '</td><td nowrap="nowrap">';
						$out .= $form->getInput($field->fieldname, $group, $defaults->get(sprintf($defaultGetName, $group, $field->fieldname)));
						$out .= '</td></tr>';
					}
				}
				$out .= '</table>';
				foreach($hidden as $field)
				{
					$out .= $field->input;
				}
			break;
			
			case 3:
				$hidden = array();
				if($title) $out .= '<h2 class="params-title">' . JText::_($fieldset->label) . '</h2>';
				if(isset($fieldset->description) && ! empty($fieldset->description)) $out .= '<p class="params-description">' . JText::_($fieldset->description) . '</p>';
				
				foreach($fields as $key => $field)
				{
					if($field->hidden)
					{
						$hidden[] = $field;
						continue;
					}
					$switch = array(
						'checkbox'
					);
					if(in_array(strtolower($field->type), $switch))
					{
						$out .= '<div class="params-line">';
						$out .= $form->getInput($field->fieldname, $group, $defaults->get(sprintf($defaultGetName, $group, $field->fieldname)));
						$out .= $field->label;
						$out .= '</div>';
					
					}
					else
					{
						$out .= '<div class="params-line">';
						$out .= $field->label;
						$out .= $form->getInput($field->fieldname, $group, $defaults->get(sprintf($defaultGetName, $group, $field->fieldname)));
						$out .= '</div>';
					}
				}
				foreach($hidden as $field)
				{
					$out .= $form->getInput($field->fieldname, $group, $defaults->get(sprintf($defaultGetName, $group, $field->fieldname)));
				}
				$out .= '<br />';
			break;
		}
		
		return $out;
	}
}