<?php
/**
 * Emerald by MintJoomla
 * a component for Joomla! 1.7 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die;

class EmeraldHelper1
{
	public static $extension = 'com_emerald';

	function alertUser($post, $admin = 0)
	{
		global $app;
		$user = JFactory::getUser($post['user_id']);
		$db = & JFactory::getDBO();

		$sid = $post['sid'] ? $post['sid'] : $post['subscription_id'];
		$sql = "SELECT name, params, alerts FROM #__jcs_plans WHERE id = '$sid'";
		$db->setQuery($sql);
		$res = $db->loadObject();
		$name = $res->name;
		$params = new JRegistry($res->params);
		$config = JFactory::getConfig();
		$alerts = new JRegistry($res->alerts);
		jimport('joomla.mail.mail');

		//$mail = new JMail();
		$mail = JFactory::getMailer();

		$sender[0] = $config->getValue('config.mailfrom');
		$sender[1] = $config->getValue('config.fromname');

		if($params->get('alert_user', 1))
		{

			if($post['published'] == 1 || $post['pay'] == 'success')
			{
				$body = $alerts->get('msg_successful', JText::_("GENERAL_ALERT_SUCCESS"));
				$subject = $alerts->get('msg_successful_sbj', sprintf(JText::_('Your Subscription created successfully')));
			}
			else
			{
				$body = $alerts->get('msg_fail', JText::_("GENERAL_ALERT_FAIL"));
				$subject = $alerts->get('msg_fail_sbj', sprintf(JText::_('Your Subscription created but not activated')));
			}

			$jf_file = JPATH_BASE.DS.'components'.DS.'com_joomfish'.DS.'joomfish.php';
			if(file_exists($jf_file))
			{
				$lang = $config->getValue('config.jflang');
				$sql = "SELECT jf.value FROM #__jf_content jf
				JOIN #__languages l ON l.id = jf.language_id
				WHERE l.code='$lang'
				AND jf.reference_table = 'emerald_plans' AND jf.reference_field = 'alerts' AND jf.published = '1' AND jf.reference_id = '$sid'";
				$db->setQuery($sql);
				if($res = $db->loadResult())
				{
					$jfparams = new JRegistry($res);

					if($post['published'] == 1 || $post['pay'] == 'success')
					$body = $jfparams->get('msg_successful');
					else
					$body = $jfparams->get('msg_fail');

				}
			}

			$body = str_replace('[USER]', str_replace("\n", " ", $user->get('name')), $body);
			$body = str_replace('[FIRST_NAME]', str_replace("\n", " ", $user->get('name')),$body);
			$body = str_replace('[SUBSCR_NAME]', '"'.$name.'"', $body);
			$body = str_replace('[SITE_NAME]', $app->getCfg('sitename'), $body);
			$body = str_replace('[SITE_URL]', JURI::root(), $body);
			$body = str_replace('[ORDER_ID]', $post['gateway_id'], $body);
			if(isset($post['transact'])){
				$body = str_replace('[TRANSACT]', $post['transact'], $body);
			}
			$body = str_replace('[PRICE]', str_replace(array("00", "Sign") , array($post['price'], EM_GENERAL_CURR), EM_LAYOUT_PRICE), $body);
			$body = str_replace('[DATE]', date("M j, Y", $post['gateway_id']), $body);
			$body = str_replace('[TIME]',  date("G:i:s", $post['gateway_id']), $body);

			if($params->get('send_as', 'text') == 'text') $body = strip_tags(str_replace("<br />", "\n", $body));

			$mail->setSender($sender);
			$mail->AddAddress($user->get('email'));
			$mail->setBody(JMailHelper::cleanBody($body));
			$mail->setSubject(JMailHelper::cleanSubject($subject));

			if ( JString::strlen($body) != JString::strlen(strip_tags($body)))
			{
				$mail->IsHTML(true);
			}

			if(!$mail->Send())
			{
				JError::raiseWarning(200, 'Error to send user alert');
			}
		}
		if($admin)
		{
			$subject = JText::_('New Subscription Alert').": [".( ($post['pay'] == 'success') ? JText::_('Success') : JText::_('Fail'))."] [{$name}]";

			$body = $alerts->get('msg_admin', JText::_("GENERAL_ALERT_ADMIN"));
			$body = str_replace('[USER]', str_replace("\n", " ", $user->get('name')),$body);
			$body = str_replace('[FIRST_NAME]', str_replace("\n", " ", $user->get('name')),$body);
			$body = str_replace('[SUBSCR_NAME]', '"'.$name.'"', $body);
			$body = str_replace('[SITE_NAME]', $app->getCfg('sitename'), $body);
			$body = str_replace('[ORDER_ID]', $post['gateway_id'], $body);
			$body = str_replace('[SITE_URL]', JURI::root()."administrator", $body);
			$body = str_replace('[EMAIL]', $user->get('email'),$body);
			$body = str_replace('[PRICE]', str_replace(array("00", "Sign") , array($post['price'], EM_GENERAL_CURR), EM_LAYOUT_PRICE), $body);
			$body = str_replace('[DATE]', date("M j, Y", $post['gateway_id']), $body);
			$body = str_replace('[TIME]',  date("G:i:s", $post['gateway_id']), $body);

			$sql = "SELECT d.fvalue, f.alias FROM #__juser_extended_fields f
			JOIN #__juser_extended_data d ON d.field_id=f.id WHERE d.user_id='".$user->id."'";
			$db->setQuery($sql);
			if($juser = $db->loadObjectList())
			{
				foreach($juser as $data)
				{
					$body = str_replace('['.strtoupper($data->alias).']', $data->fvalue, $body);
				}
			}

			if($params->get('send_as', 'text') == 'text') $body = strip_tags(str_replace("<br />", "\n", $body));

			$mail->ClearAllRecipients();

			$mail->AddAddress($sender[0]);

			if($extra_emails = $params->get('extra_emails'))
			{
				$extra_emails = str_replace(', ', ',', $extra_emails);
				$extra_emails = explode(',', $extra_emails);
				$mail->AddCC($extra_emails);
			}
			$mail->setBody(JMailHelper::cleanBody($body));
			$mail->setSubject(JMailHelper::cleanSubject($subject));
			if ( JString::strlen($body) != JString::strlen(strip_tags($body)))
			{
				$mail->IsHTML(true);
			}

			if(!$mail->Send())
			{
				JError::raiseWarning(200, 'Error to send admin alert');
			}
		}
	}


	public static function addSubmenu5($vName)
	{
		
		JSubMenuHelper::addEntry(
			JText::_('Subscription plans'),
			'index.php?option=com_emerald&view=plans',
			$vName == 'plans'
			);
		JSubMenuHelper::addEntry(
			JText::_('User subscriptions'),
			'index.php?option=com_emerald&view=users',
			$vName == 'users');
		JSubMenuHelper::addEntry(
			JText::_('Plan category'),
			'index.php?option=com_categories&extension=com_emerald',
			$vName == 'categories'		
			);
			
		if ($vName=='categories') {
			JToolBarHelper::title(
				JText::sprintf('COM_CATEGORIES_CATEGORIES_TITLE',JText::_('com_emerald')),
				'plan-categories');
		}
		JSubMenuHelper::addEntry(
			JText::_('Coupons'),
			'index.php?option=com_emerald&view=coupon',
			$vName == 'coupons'
			);
		JSubMenuHelper::addEntry(
			JText::_('Payment Plugins'),
			'index.php?option=com_plugins&filter_folder=emerald',
			$vName == 'paymment_plug'		
			);
		JSubMenuHelper::addEntry(
			JText::_('About'),
			'index.php?option=com_emerald&view=plans&layout=about'
		);

		
	}

}

?>