<?php
/**
 * Emerald by MintJoomla
 * a component for Joomla! 1.7 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('dead');

jimport('joomla.application.component.modellist');

class EmeraldModelCoupon extends JModelList
{
    
    function __construct()
    {
        parent::__construct();
        
        global $app, $option;

		$limit      = $this->getUserStateFromRequest( 'global.list.limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$limitstart = $this->getUserStateFromRequest( $option.'coupon.limitstart', 'limitstart', 0, 'int' );

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
		
		$array = JRequest::getVar('cid', array(0), '', 'array');
		$this->setId((int)$array[0]);
	}
	
	function getListQuery()
	{
		global $app, $option;
		// Create a new query object.
		$db = $this->getDbo ();
		$query = $db->getQuery ( true );
		$query->select("* , ctime AS `start`, extime AS `finish`, IF(extime < NOW(),1,0) AS expire,  IF(used_num >= use_num,1,0) AS usedout");
		$query->from('#__jcs_coupons');
		
		
		$filter_state		= $app->getUserStateFromRequest( $option.'coupons.filter_state',		'filter_state',		'',				'word' );
		$filter_type		= $app->getUserStateFromRequest( $option.'coupons.filter_type',		'filter_type',		'',			'string' );
        $search				= $app->getUserStateFromRequest( $option.'coupons.search',			'search',			'',				'string' );
		$search				= JString::strtolower( $search );
		$filter_order		= $app->getUserStateFromRequest( $option.'coupons.filter_order',		'filter_order',		'value',	'cmd' );
		$filter_order_Dir	= $app->getUserStateFromRequest( $option.'coupons.filter_order_Dir',	'filter_order_Dir',	'DESC',				'word' );

		$where = array();
		if ($search) {
			$w  = ' ( LOWER(value) LIKE '.$db->Quote('%'.$search.'%');
			$w .= ' OR LOWER(discount_type) LIKE '.$db->Quote('%'.$search.'%');
			$w .= ' )';
			$query->where($w);
		}

		if ($filter_type) {
			$query->where("discount_type = '".$filter_type."'");
		}
		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
				$query->where('published = 1');
			} else if ($filter_state == 'U' ) {
				$query->where('published = 0');
			}
		}
		
		$query->order($filter_order.' '.$filter_order_Dir); 
		
		return $query;
	}

	function setId($id)
	{
		$this->_id		= $id;
		$this->_data	= null;
		$this->_plan	= null;
	}
	function getPlan()
	{
		if ($this->_plan == null)
		{
			if($this->_id)
			{
				$query = 'SELECT * FROM #__jcs_coupons WHERE id = '.(int) $this->_id;
				$this->_db->setQuery($query);
				$this->_plan = $this->_db->loadObject();
				return $this->_plan;
			}
			else 
			{
				return $this->initData();
			}
		}
		return $this->initData();
	}
	function initData()
	{
		$plan = new stdClass();
		$plan->id = null;
		$plan->value = '';
		$plan->discount = 0;
		$plan->discount_type = 'procent';
		$plan->user_ids = '';
		$plan->strict = 0;
		$plan->ctime = strftime('%Y-%m-%d %H:%M:%S', time());
		$plan->extime = 'Never';
		$plan->use_user = 0;
		$plan->use_num = 0;
		$plan->used_num = 0;
		$plan->trash = 0;
		$plan->checked_out = 0;
		$plan->checked_out_time = null;
		$plan->published = 1;
		$plan->plan_ids = '';
		$this->_plan = $plan;
		return $plan;
	}
	function store($data)
	{
		$row =& $this->getTable();
		
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			//echo "1111"; exit;
			return false;
		}
		
		if (!$row->check()) {
			$this->setError('Check fail'. $row->_error);
			//echo "1111"; exit;
			return false;
		}
		
		if (!$row->store()) {
			$this->setError('Cannot Store'. $row->getError());
			return false;
		}
		$this->id = $row->id;
		
		return true;
	}
	function checkin()
	{
		if ($this->_id)
		{
			$coupon = & $this->getTable();
			if(! $coupon->checkin($this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return false;
	}
}
?>   