CREATE TABLE  IF NOT EXISTS `#__jcs_exp_alerts` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `user_subscription_id` int(10) unsigned NOT NULL default '0',
  `user_id` int(10) unsigned NOT NULL default '0',
  `stime` datetime NOT NULL default '0000-00-00 00:00:00',
  `sent` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY  (`id`)
)  ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__jcs_history` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `user_id` int(10) unsigned NOT NULL default '0',
  `url` text NOT NULL,
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
  `subscription_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS  `#__jcs_plans` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(155) NOT NULL default '',
  `days` int(10) unsigned NOT NULL default '0',
  `price` float(10,2) NOT NULL default '0.00',
  `description` text NOT NULL,
  `published` tinyint(1) unsigned NOT NULL default '1',
  `type_category` tinyint(1) unsigned NOT NULL default '0',
  `category` text NOT NULL,
  `params` text NOT NULL,
  `grant_reg` tinyint(1) unsigned NOT NULL default '0',
  `grant_new` tinyint(1) unsigned NOT NULL default '0',
  `checked_out` int(11) NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `granturl` int(10) unsigned NOT NULL default '0',
  `days_type` set('hours','days','weeks','months','years') NOT NULL default 'days',
  `time_limit` int(10) unsigned NOT NULL default '0',
  `one_time` tinyint(1) unsigned NOT NULL default '0',
  `alert_admin` tinyint(1) unsigned NOT NULL default '0',
  `component` text NOT NULL,
  `type_component` tinyint(1) unsigned NOT NULL default '0',
  `type_user` tinyint(1) unsigned NOT NULL default '0',
  `type_article` tinyint(1) unsigned NOT NULL default '0',
  `adwords` mediumtext NOT NULL,
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
  `discount` float(10,2) NOT NULL default '0.00',
  `invisible` tinyint(1) unsigned NOT NULL default '0',
  `ordering` tinyint(3) unsigned NOT NULL default '0',
  `catid` int(10) unsigned NOT NULL default '0',
  `finish_msg` text NOT NULL,
  `gid` int(10) unsigned NOT NULL default '18',
  `usertype` varchar(45) NOT NULL default 'Registered',
  `data_fixed` tinyint(1) unsigned NOT NULL default '0',
  `contentcategory` text NOT NULL,
  `cross_plans` text NOT NULL,
  `alerts` text NOT NULL,
  `auto_child_plans` text NOT NULL, 
  `invisible_in_history` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY  (`id`)
)  ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS `#__jcs_user_subscr` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `user_id` int(10) unsigned NOT NULL default '0',
  `subscription_id` int(10) unsigned NOT NULL default '0',
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
  `published` tinyint(1) unsigned NOT NULL default '1',
  `extime` datetime NOT NULL default '0000-00-00 00:00:00',
  `price` float(10,2) NOT NULL default '0.00',
  `number` varchar(200) NOT NULL default '',
  `access_count` int(10) unsigned NOT NULL default '0',
  `access_limit` int(10) unsigned NOT NULL default '0',
  `gateway` varchar(45) NOT NULL default 'undefined',
  `gateway_id` varchar(200) NOT NULL default '',
  `created` datetime NOT NULL default '0000-00-00 00:00:00',
  `checked_out` int(10) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `parent` tinyint(1) unsigned NULL default '0',
  `never_activated` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `tracking` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY  (`id`)
)  ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS  `#__jcs_coupons` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `value` varchar(100) NOT NULL default '',
  `discount` double(12,2) NOT NULL default '0.00',
  `discount_type` set('procent','sum', 'fixed') NOT NULL default 'procent',
  `user_ids` text NOT NULL,
  `strict` tinyint(1) unsigned NOT NULL default '0' COMMENT 'only specified user can use this',
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
  `extime` datetime NOT NULL default '0000-00-00 00:00:00',
  `use_num` int(10) unsigned NOT NULL default '0',
  `used_num` int(10) unsigned NOT NULL default '0',
  `trash` tinyint(1) unsigned NOT NULL default '0',
  `checked_out` int(10) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `published` tinyint(1) unsigned NOT NULL default '0',
  `plan_ids` text NOT NULL,
  `use_user` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `trash` (`trash`),
  KEY `extime` (`extime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE  IF NOT EXISTS `#__jcs_coupons_history` (
  `id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `coupon_id` int(11) NOT NULL default '0',
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
  `plan_id` int(11) NOT NULL default '0',
  `price` float(10,2) NOT NULL default '0.00',
  `discount` float(10,2) NOT NULL default '0.00',
  `discount_type` varchar(20) NOT NULL default '',
  `subscription_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY  (`id`)
)  ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE  IF NOT EXISTS `#__community_activity` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `icon` varchar(255) NOT NULL,
  `text` text NOT NULL,
  `client` varchar(128) NOT NULL,
  `client_id` int(10) unsigned NOT NULL,
  `component` varchar(45) NOT NULL,
  `ctime` datetime NOT NULL,
  `params` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `Index_2` (`client`),
  KEY `Index_3` (`client_id`)
)  ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `#__community_events` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `title` varchar(255) NOT NULL,
  `text` text NOT NULL,
  `ctime` datetime NOT NULL,
  `priority` int(10) unsigned NOT NULL,
  `user_id` int(10) unsigned NOT NULL,
  `component` varchar(45) NOT NULL,
  `params` text NOT NULL,
  `controller` varchar(255) NOT NULL,
  `published` tinyint(3) unsigned NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `Index_2` (`user_id`),
  KEY `Index_3` (`component`),
  KEY `Index_4` (`priority`),
  KEY `Index_5` (`published`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;