<?php
/**
 * Emerald by MintJoomla
 * a component for Joomla! 1.7 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

jimport('joomla.application.component.view');

class EmeraldViewCoupon extends JView
{

	function display($tpl = null)
	{
		global $app, $TB, $Itemid;

		if ($this->getLayout() == 'form')
		{
			$this->_form($tpl);
			return;
		}

		JToolBarHelper::title(JText::_('Coupons'), 'generic.png');
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::deleteList();
		JToolBarHelper::editListX();
		JToolBarHelper::addNewX();
		JToolBarHelper::preferences('com_emerald');

		JHTML::_('behavior.tooltip');
		JHTML::_('behavior.calendar');
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$option = JRequest::getVar('option', 'com_emerald');

		$filter_state = $app->getUserStateFromRequest($option . 'coupons.filter_state', 'filter_state', '', 'word');
		$filter_type = $app->getUserStateFromRequest($option . 'coupons.filter_type', 'filter_type', '', 'string');
		$filter_order = $app->getUserStateFromRequest("{$option}.view_coupons.filter_order", 'filter_order', 'value');
		$filter_order_Dir = $app->getUserStateFromRequest("{$option}.view_coupons.filter_order_Dir", 'filter_order_Dir', 'ASC');
		$limit = $app->getUserStateFromRequest("{$option}.view_coupons.limit", 'limit', $app->getCfg('list_limit'), 0);
		$limitstart = JRequest::getVar('limitstart', 0, '', 'int');
		$search = $app->getUserStateFromRequest($option . 'coupons.search', 'search', '', 'string');
		$search = JString::strtolower($search);

		if ($filter_order)
			$orderby = "\n ORDER BY $filter_order $filter_order_Dir";

		$rows = $this->get('Items');

		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;

		$javascript = 'onchange="submitform();"';

		$opt = array();
		$opt[] = JHTML::_('select.option', 0, '- ' . JText::_('Select coupon type') . ' -', 'id', 'title');
		$opt[] = JHTML::_('select.option', 'procent', JText::_('Discount'), 'id', 'title');
		$opt[] = JHTML::_('select.option', 'sum', JText::_('Gift certificate'), 'id', 'title');
		$opt[] = JHTML::_('select.option', 'fixed', JText::_('Fixed sum'), 'id', 'title');
		$lists['type'] = JHTML::_('select.genericlist', $opt, 'filter_type', 'class="inputbox" ' . $javascript, 'id', 'title', $filter_type);

		// state filter
		$lists['state'] = JHTML::_('grid.state', $filter_state);
		// search filter
		$lists['search'] = $search;

		$this->lists = $lists;
		$this->rows = $rows;
		$this->pagination = $this->get('Pagination');
		parent::display($tpl);
	}

	function _form($tpl = null)
	{
		global $app, $option;

		$db = JFactory::getDBO();
		$uri = JFactory::getURI();
		$user = JFactory::getUser();

		JHTML::_('behavior.tooltip');
		JHTML::_('behavior.calendar');

		$row = $this->get('Plan');

		$isNew = ($row->id < 1);

		$text = $isNew ? JText::_('New') : JText::_('Edit');
		JToolBarHelper::title(JText::_('Coupon') . ': <small><small>[ ' . $text . ' ]</small></small>');
		JToolBarHelper::save();
		JToolBarHelper::apply();
		if ($isNew)
		{
			JToolBarHelper::cancel();
		}
		else
		{
			// for existing items the button is renamed `close`
			JToolBarHelper::cancel('cancel', 'Close');
		}

		$lists['published'] = JHTML::_('select.booleanlist', 'published', 'class="inputbox"', $row->published);
		$types[] = JHTML::_('select.option', 'procent', "%, " . mb_strtolower(JText::_('Discount')));
		$types[] = JHTML::_('select.option', 'sum', EM_GENERAL_CURR . ", " . mb_strtolower(JText::_('Gift certificate')));
		$types[] = JHTML::_('select.option', 'fixed', EM_GENERAL_CURR . ", " . mb_strtolower(JText::_('Fixed sum')));
		$lists['type'] = JHTML::_('select.genericlist', $types, 'discount_type', 'class="inputbox"', 'value', 'text', $row->discount_type);

		$lists['ctime'] = JHTML::_('calendar', $row->ctime ? $row->ctime : 'Never', 'ctime', 'ctime', '%Y-%m-%d %H:%M:%S', array('class' => 'inputbox'));
		$lists['extime'] = JHTML::_('calendar', $row->extime ? $row->extime : 'Never', 'extime', 'extime', '%Y-%m-%d %H:%M:%S', array('class' => 'inputbox'));

		$this->lists = $lists;
		$this->row = $row;
		$this->isNew = $isNew;
		parent::display($tpl);
	}
}
?>
