<?php
/**
 * Emerald by MintJoomla
 * a component for Joomla! 1.7 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

/**
 * Member API file
 *
 * To use those functions you need to setup on your side like described here
 * http://support.mightyextensions.com/en/mighty-membership-subscription-joomla-component/ideas
 *
 */
class EmeraldApi
{

	public static function addCount($plans, $mode, $user_id = 0)
	{
		if (!$user_id)
		{
			$user = JFactory::getUser();
			$user_id = $user->get('id');
		}
		if (!$user_id)
		{
			return;
		}
		
		$db = JFactory::getDBO();
		
		if (is_array($plans))
		{
			$plans = implode(',', $plans);
		}
		$res = FALSE;
		if ($mode == 1)
		{
			$url = JFactory::getURI();
			
			$sql = 'SELECT subscription_id AS sid FROM #__jcs_history WHERE user_id = ' . $user_id;
			$sql .= ' AND subscription_id IN (' . $plans . ') ';
			$sql .= ' AND url = \'' . $db->getEscaped($url->toString()) . '\'';
			$db->setQuery($sql);
			$res = $db->loadResult();
		}
		if (!$res)
		{
			$query = "SELECT u.id, s.id as sid, IF(u.access_limit > 0, IF(u.access_count >= u.access_limit, 0, 1), 1) AS cl
					FROM #__jcs_plans AS s 
					LEFT JOIN #__jcs_user_subscr AS u ON s.id = u.subscription_id
				    WHERE s.id IN (SELECT subscription_id FROM #__jcs_user_subscr WHERE subscription_id IN(" . $plans . ") 
				   		 AND user_id = {$user_id}
		                 AND extime > NOW()
		                 AND ctime < NOW()
		                 AND published = 1
	                 )	                 
				   	AND s.published = 1
	                HAVING cl > 0
	                ORDER BY u.extime DESC LIMIT 1";
			$db->setQuery($query);
			$planId = $db->loadObject();
			
			if ($planId)
			{
				$sql = "UPDATE #__jcs_user_subscr SET access_count = access_count + 1 WHERE id = {$planId->id}";
				$db->setQuery($sql);
				$db->query();
				if ($mode == 1)
				{
					$sql = "INSERT INTO #__jcs_history VALUES(NULL, {$user_id}, '" . $db->getEscaped($url->toString()) . "', NOW(), {$planId->sid})";
					$db->setQuery($sql);
					$db->query();
				}
			}
		
		}
	
	}

	/**
	 * This function check if user have subscriptions required.
	 * Example of usage
	 *
	 * if($params->get('plans'))
	 * {
	 * jscCheckSubscription($params->get('plans'),
	 * JText::_('You need subscription to access this page'),
	 * $itemid, true, $params->get('count_mode'))
	 * }
	 *
	 * Where $params->get('plans') and $params->get('count_mode') are parameters that
	 * is set using method described here
	 * http://joomsuite.com/index.php?option=com_resource&controller=article&article=2823&category_id=45&Itemid=82
	 *
	 * @param mixed 	$plans 	may be string 12,23,1,3 or array of IDs of plans set
	 * to restrict something
	 * @param string 	$msg 	Message to desplay on subscription form
	 * @param integer 	$itemid Itemid of subscription page
	 * @param boolean 	$redirect Redirect to subscription if access restricted or
	 * return true or false
	 * @param integer 	$mode	Count limit mode
	 * @return boolean
	 */
	
	public static function hasSubscription($plans, $msg, $itemid, $redirect = true, $mode = 0, $user_id = 0)
	{
		$app = JFactory::getApplication();
		
		if (!$user_id)
		{
			$user = JFactory::getUser();
			$user_id = $user->get('id');
		}
		
		$db = JFactory::getDBO();
		$url = JFactory::getURI();
		if (is_array($plans))
		{
			$plans = trim(implode(',', $plans));
		}
		
		if(!$plans)
		{
			return true;
		}
		
		if (!$user_id)
		{
			if ($redirect)
			{
				JError::raiseWarning(403, $msg);
				JError::raiseWarning(403, Jtext::_('You are not loged-in'));
				$return = urlencode(base64_encode(JRoute::_('index.php?option=com_emerald&view=plans&layout=form&Itemid=' . $itemid . '&id=' . $plans, false)));
				$app->redirect(JRoute::_('index.php?option=com_users&view=login&return=' . $return, false));
			}
			return false;
		}
		
		$query = "
		SELECT u.*, IF(u.access_limit > 0 AND {$mode} > 0, IF(u.access_count >= u.access_limit, IF({$mode} = 1 AND h.url = '" . $db->getEscaped($url->toString()) . "', 1, 0), 1), 1) AS cl
		          FROM #__jcs_plans AS s 
		     LEFT JOIN #__jcs_user_subscr AS u ON s.id = u.subscription_id 
		     LEFT JOIN #__jcs_history AS h ON (h.subscription_id = s.id AND h.user_id = u.user_id)
		        WHERE s.id IN (" . $plans . ")
		        	AND s.published = 1
                   AND u.user_id = {$user_id}
                   AND u.extime > NOW()
                   AND u.ctime < NOW()
                   AND u.published = 1
	            HAVING cl > 0";
		$db->setQuery($query);
		//echo str_replace('#_', 'jos', $db->getQuery());
		if (!$db->loadObjectList())
		{
			if ($redirect)
			{
				JError::raiseWarning(403, JText::_($msg));
				$app->redirect(JRoute::_('index.php?option=com_emerald&view=plans&layout=form&Itemid=' . $itemid . '&id=' . $plans, false));
			}
			return false;
		}
		
		return true;
	}

	function getUserSubscr($user_id)
	{
		$db = JFactory::getDBO();
		$sql = "SELECT up.id, up.gateway, up.gateway_id, up.access_limit,
		up.published, up.access_count,
		up.price, up.checked_out,
		up.created, up.ctime, up.extime, p.name,
		(TO_DAYS(up.extime) - TO_DAYS(NOW())) as days, p.id AS pid
		FROM #__jcs_user_subscr AS up
		LEFT JOIN #__jcs_plans AS p ON up.subscription_id = p.id
		WHERE up.user_id = '$user_id'";
		$db->setQuery($sql);
		return $db->loadObjectList();
	}
	
	public static function getSubscriptions($plans)
	{
		if(is_array($plans))
		{	
			$plans = implode(', ', $plans);			
		}
		$db = JFactory::getDBO();
		$sql = "SELECT * FROM #__jcs_plans WHERE id IN ($plans) ORDER BY id";
		$db->setQuery($sql);
		return $db->loadObjectList();
	} 
}
?>