<?php
/**
 * Emerald by MintJoomla
 * a component for Joomla! 1.7 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class EmeraldControllerPlans extends EmeraldController
{
	var $couponExists = false;
	var $couponValid = false;
	var $couponError = '';

	public function display($cachable = false, $urlparams = false)
	{

		$user = JFactory::getUser();
		$menus = JSite::getMenu();
		$menu = $menus->setActive(JRequest::getInt('Itemid'));
		$menu = $menus->getActive();
		if (is_object($menu))
		{
			$params = new JRegistry($menu->params);
			$template = $params->get('form_tmpl', 'standard');
		}
		else
			$template = 'standard';
		if (!$user->get('id') && $template != 'select')
		{
			JRequest::setVar('layout', 'form');
		}

		parent::display();
	}

	function pay()
	{
		global $app;

		$sid = JRequest::getInt('subscr_id');
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$coupon = JRequest::getVar('coupon');
		$url = 'index.php?option=com_emerald&view=plans&layout=form&Itemid=' . (EM_IID_PLANS != '' ? EM_IID_PLANS : JRequest::getInt('Itemid'));

		/*if(!$user->id)
		{
		    $mainframe->enqueueMessage(JText::_('Please login to continue'), 'Error');
			$this->setRedirect($url);
			return;
		}*/

		$dispatcher = JDispatcher::getInstance();

		$model = $this->getModel('plans');
		if (!$sid)
		{
			$msg = JText::_('You can not purchase this subscription');
			$app->enqueueMessage($msg, 'Error');
			$this->setRedirect($url);
			return;
		}
		$sql = "SELECT id, days, discount, price, name, params, days_type,
		days, cross_plans, alert_admin
		FROM #__jcs_plans WHERE id = $sid";
		$db->setQuery($sql);
		$rows = $db->loadObjectList();
		$plan = $rows[0];
		$alert = '';
		$plan_param = new JRegistry($plan->params);

		if ($plan->cross_plans != '')
		{
			$plan->price = $model->calculatePrice($sid, $plan->cross_plans, $plan->price, $plan->params);
			$alert = $model->getAlert($sid, $plan->cross_plans, $plan->params);

		}
		if ($plan_param->get('cp_plans'))
			$params['ctime'] = $model->getCrossPeriod($sid, $plan_param->get('cp_plans'), $user->id);

		$params['order_amount'] = $plan->price;

		if ($plan->discount > 0)
		{
			$sql = "SELECT count(*)  FROM #__jcs_user_subscr WHERE subscription_id = $sid AND user_id = " . $user->get('id');
			$db->setQuery($sql);
			$subscr = $db->loadResult();
			if ($subscr > 0)
			{
				if ($disc_period = $plan_param->get('discount_period', 0))
				{
					$sql = "SELECT IF( (TO_DAYS( NOW() ) - TO_DAYS(extime)) < $disc_period, 1, 0 ) as count_discount
					FROM #__jcs_user_subscr  WHERE subscription_id = '$sid' AND user_id = '" . $user->get('id') . "'
					ORDER BY extime DESC LIMIT 1";
					$db->setQuery($sql);
					if ($count_discount = $db->loadResult())
					{
						$params['order_amount'] = round(($params['order_amount'] - ($params['order_amount'] * ($plan->discount / 100))), 2); // (1 + ($row->discount / 100));

						$params['a1'] = $plan->price;
						$params['a3'] = round(($params['order_amount'] - ($params['order_amount'] * ($plan->discount / 100))), 2);
					}
				}
				else
				{
					$params['order_amount'] = round(($params['order_amount'] - ($params['order_amount'] * ($plan->discount / 100))), 2); // (1 + ($row->discount / 100));

					$params['a1'] = $plan->price;
					$params['a3'] = round(($params['order_amount'] - ($params['order_amount'] * ($plan->discount / 100))), 2);
				}
			}
		}

		$params['processor'] = JRequest::getVar('processor');
		$params['order_id'] = $sid;
		$params['order_title'] = $app->getCfg('sitename') . ' :: ' . $plan->name;
		$params['order_quantity'] = 1;
		$params['user_id'] = $user->get('id');
		$params['task'] = 'plans.create';
		$params['view'] = 'plans';
		$params['layout'] = 'history';
		$params['option'] = 'com_emerald';
		$params['params'] = $plan->params;
		$params['days_type'] = $plan->days_type;
		$params['days'] = $plan->days;
		$params['prod_id'] = $params['order_id'];
		$params['Itemid'] = JRequest::getInt('Itemid');
		$params['currency'] = $plan_param->get('currency');

		$is_mua = false;

		if (substr($coupon, 0, 3) == "MUA")
		{
			$mua = explode("-", $coupon);
			$sql = "SELECT * FROM #__jcs_user_subscr WHERE user_id = '{$user->id}' AND parent='{$mua[1]}'";
			$db->setQuery($sql);
			$user_sub = $db->LoadObject();
			if ($user_sub)
			{
				JError::raiseNotice(100, JText::_('You have already used this coupon to get the subscription'));
				parent::display();
				return;
			}
			if (!$user_sub)
			{

				$result = $model->getUserSubscrInfo($mua[1]);

				if (time() > strtotime($result->extime))
				{
					JError::raiseNotice(100, JText::_('Parent subscription has expired'));
					parent::display();
					return;
				}
				if ($sid == $result->plan_id)
				{
					$code = md5($result->user_id . $sid . $mua[1] . $result->ctime);
					$code = strtoupper(substr($code, 0, 10));
					$mua_params = new JRegistry($result->params);
					$mua_subscr = $model->getSubscrMUA($mua[1]);
					if ($code == $mua[2] && count($mua_subscr) < $mua_params->get('muaccess'))
					{
						$coupon = false;
						$params['order_amount'] = 0;
						$is_mua = true;
					}
				}
			}
		}
		$coupon_data = new stdClass();
		$coupon_data->id = '';

		if ($coupon && ($params['order_amount'] > 0))
		{
			$this->initCoupon($coupon);
			if (!$this->couponExists)
			{
				JError::raiseNotice(100, JText::_('Coupon or Gift Certificate number do not exists'));
				parent::display();
				return;
			}
			else
			{
				if (!$this->couponValid)
				{
					JError::raiseNotice(100, JText::_('Coupon or Gift Certificate is not valid'));
					JError::raiseNotice(100, JText::_($this->couponError));
					parent::display();
					return;
				}
				else
				{
					$params['a3'] = $plan->price;
					$coupon_data = $this->applyCoupon($coupon, $params['order_amount']);
					$params['order_amount'] = $coupon_data->out;
					$params['a1'] = $params['order_amount'];
				}
			}
		}
		if ($coupon_data->id != '')
			$params['order_id'] .= '::' . $coupon_data->id;

		if ($params['order_amount'] <= 0)
		{
			$res['sid'] = $sid;
			$res['gateway'] = '.zero-price';
			$res['gateway_id'] = time();
			$res['user_id'] = $user->get('id');
			$res['pay'] = 'success';
			$res['price'] = '0.00';

			if ($is_mua)
			{
				$res['gateway'] = '.multi_user_access';
				$res['pay'] = 'mua';
				$res['parent'] = $mua[1];
				$res['extime'] = $result->extime;
			}

			JRequest::setVar('data', $res);

			if ($alert == '')
			{
				if (!$sid || !$res['gateway'] || !$res['gateway_id'] || !$res['user_id'] || !array_key_exists('price', $res) || !$res['pay'])
				{
					$msg = JText::_('Not all information is passed to create subscription');
					$app->enqueueMessage($msg, 'Error');
					$this->setRedirect($url);
					return;
				}

				if ($model->store($res))
				{
					$msg = JText::_('Your Subscription Created Successfuly');

					// creating grant plans
					$model->grantPlans($res);

					$model->deactivatePlans($res['sid'], $res);

					if ($coupon_data->id && $coupon_data->id != '')
					{
						$sql = "UPDATE #__jcs_coupons_history SET subscription_id = '{$model->subscription_id}' WHERE id = '{$coupon_data->id}'";
						$db->setQuery($sql);
						$db->query();
					}

					JPluginHelper::importPlugin('system');
					$dispatcher->trigger('onAfterStoreFreeSubscription', array(&$plan, &$model));

					EmeraldHelper::alertUser($res, $plan->alert_admin);

				}
				else
				{
					JError::raiseError(503, JText::_('Could not save subscription'));
				}
			}
			else
			{
				$msg = JText::_('You can not purchase this subscription');
			}
			if(defined('EM_GAT_ENABLE') && defined('EM_GAT') && EM_GAT_ENABLE && EM_GAT != '' && $model->subscription_id)
			{
				$session = JFactory::getSession();
				$gat = array('gateway_id' => $res['gateway_id'], 'price' => $res['price'],
					'sid' => $model->subscription_id, 'status' => $res['pay'], 'name' => $plan->name);
				$session->set('gatracking-'.$res['user_id'], $gat);
			}
			$url1 = ($plan_param->get('redirect')) ? $plan_param->get('redirect') : 'index.php?option=com_emerald&view=plans&layout=history&plan=' . $res['sid'] . '&Itemid=' . EM_HISTORY;
			$app->enqueueMessage($msg, ($alert == '') ? '' : 'Error');
			$this->setRedirect($url1);

			return;
		}
		if ($alert != '')
		{
			$msg = JText::_('You can not purchase the subscription');
			//$url = 'index.php?option=com_emerald&view=plans&layout=history&plan='.$res['sid'].'&Itemid='.EM_HISTORY;
			$app->enqueueMessage($msg, 'Error');
			$this->setRedirect($url);

			return;
		}

		JPluginHelper::importPlugin('emerald');
		$dispatcher->trigger('onSendPayment', array(& $params));
		parent::display();
	}

	function applyCoupon($coupon, $price)
	{
		$db = JFactory::getDBO();
		$user = JFactory::getUser();

		$sql = "UPDATE #__jcs_coupons SET used_num = used_num + 1 WHERE `value` = '" . addslashes($coupon) . "'";
		$db->setQuery($sql);
		$db->query();

		$sql = "SELECT * FROM #__jcs_coupons WHERE `value` = '" . addslashes($coupon) . "'";
		$db->setQuery($sql);
		$rows = $db->loadObjectList();
		$row = $rows[0];
		$sid = JRequest::getInt('subscr_id');

		//$price = JRequest::getVar('price'.$sid);


		$sql = "INSERT INTO #__jcs_coupons_history
		(`id` ,	`user_id` ,	`coupon_id` ,	`ctime` ,	`plan_id` ,	`price` , `discount` , `discount_type`, `subscription_id` )
			VALUES (NULL, '" . $user->get('id') . "', '{$row->id}', NOW(), '$sid', '$price', '{$row->discount}', '{$row->discount_type}', '')";
		$db->setQuery($sql);
		$db->query();
		$res = new stdClass();
		$res->id = $db->insertid();

		if ($row->discount_type == 'procent')
		{
			$out = $price - ($price * ($row->discount / 100));
			$out = round($out, 2);
			$res->out = $out;
			return $res;
		}
		else
		{
			if ($row->discount_type == 'sum')
			{
				$new = round(($row->discount - $price), 2);
				if ($new < 0)
					$new = 0;
				$sql = "UPDATE #__jcs_coupons SET discount = '{$new}' WHERE `value` = '" . addslashes($coupon) . "'";
				$db->setQuery($sql);
				$db->query();
			}

			$out = $price - $row->discount;
			if ($out < 0)
				$out = 0;
			$out = round($out, 2);
			$res->out = $out;
			return $res;
		}
	}

	function initCoupon($coupon)
	{
		$db = JFactory::getDBO();

		$sql = "SELECT *,  IF( extime > NOW() or YEAR(extime) =  0 , 0, 1)  as expired FROM #__jcs_coupons WHERE `value` = '" . addslashes($coupon) . "' AND `published` = 1 AND `ctime` <= NOW()";
		$db->setQuery($sql);
		if ($rows = $db->loadObjectList())
		{
			$row = $rows ? $rows[0] : false;

			$this->couponValid = true;

			if ($row->value)
			{
				$this->couponExists = true;
			}
			else
			{
				$this->couponExists = false;
			}

			if (($row->use_num > 0) && ($row->used_num >= $row->use_num))
			{
				$this->couponValid = false;
				$this->couponError = 'Coupon used out';
			}

			if (($row->discount_type == 'sum') && ($row->discount <= 0))
			{
				$this->couponValid = false;
				$this->couponError = 'Coupon used out';
			}

			if ($row->expired)
			{
				$this->couponValid = false;
				$this->couponError = 'Coupon expired';
			}

			if ($row->user_ids)
			{
				$user = JFactory::getUser();
				$ids = explode(",", $row->user_ids);
				if (!in_array($user->get('id'), $ids))
				{
					$this->couponValid = false;
					$this->couponError = 'You are not allowed to use this coupon';
				}
			}
			if ($row->plan_ids)
			{
				$ids = explode(",", $row->plan_ids);
				$sid = JRequest::getInt('subscr_id');
				if (!in_array($sid, $ids))
				{
					$this->couponValid = false;
					$this->couponError = 'This coupon is not valid for this subscription plan';
				}
			}
			if ($row->use_user > 0)
			{
				$user = JFactory::getUser();

				$sql = "SELECT count(*) FROM #__jcs_coupons_history WHERE `coupon_id` = '{$row->id}' AND user_id = " . $user->get('id');
				$db->setQuery($sql);
				$num = $db->loadResult();

				if ($num >= $row->use_user)
				{
					$this->couponValid = false;
					$this->couponError = 'You have used this coupon amount of times allowed';
				}
			}
		}

	}

	function create()
	{
		global $app;
		$db = JFactory::getDBO();

		$dispatcher = JDispatcher::getInstance();
		JPluginHelper::importPlugin('emerald');
		$request = (array)JRequest::get('request');
		if($request['processor'] == 'paygoogleco')
			$order_id = $request['shopping-cart_items_item-1_merchant-item-id'];
		else
			$order_id = urldecode(JRequest::getVar('order_id'));
		$order_id = explode('::', $order_id);
		$order_id = (int)$order_id[0];


		$sql = "SELECT * FROM #__jcs_plans WHERE id = " . $order_id;
		$db->setQuery($sql);
		$plan = $db->loadObject();
		$param = array_merge($request, array('params' => @$plan->params));

		$result = $dispatcher->trigger('onReceivePayment', array(& $param));

		if (empty($result) || !is_array($result))
		{
			//error_log("\n[Create log !is_array ]: " . print_r($result, true), 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS . 'paypaypal' . DS . 'log.txt');
			$app->enqueueMessage('No value found');
			$app->redirect(JRoute::_('index.php?option=com_emerald&view=plans&layout=history&Itemid=' . (EM_HISTORY != '' ? EM_HISTORY : JRequest::getInt('Itemid')), false));
			return;
		}
		$payment = array();
		@$payment['pay'] == 'fail';

		foreach($result as $res)
		{
			if (is_array($res))
			{
				//error_log("\n[Res is_array ]: " . print_r($res, true), 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS . 'payrbk' . DS . 'log.txt');
				if (@isset($res['msg']))
					$app->enqueueMessage($res['msg']);

				$model = JModel::getInstance('Plans', 'EmeraldModel');

				$order = explode('::', urldecode($res['sid']));
				$coupon_id = (int)@$order[1];
				$sid = $order[0];


				if (!$sid || !$res['gateway'] || !$res['gateway_id'] || !$res['user_id'] || !array_key_exists('price', $res) || !$res['pay'])
				{
					//error_log("\n[Not All Information is Passed ]: ", 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS . 'paypaypal' . DS . 'log.txt');
					$link = JRoute::_('index.php?option=com_emerald&view=plans&layout=form&Itemid=' . (EM_IID_PLANS != '' ? EM_IID_PLANS : JRequest::getInt('Itemid')), false);

					$msg = JText::_('Not All Information is Passed to create subscription');
				}
				else
				{
					JRequest::setVar('data', $res);

					if ($model->store($res))
					{
						//error_log("\n[Stored ]: ", 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS . 'paypaypal' . DS . 'log.txt');
						$msg = JText::_('Your Subscription Created Successfully');
						if (!$model->published)
							$msg .= ' ' . JText::_('But not activated automaticaly');

					// creating grant plans
						$model->grantPlans($res);

						$model->deactivatePlans($sid, $res);

						if ($coupon_id && $coupon_id != '')
						{
							$sql = "UPDATE #__jcs_coupons_history SET subscription_id = '{$model->subscription_id}' WHERE id = '$coupon_id'";
							$db->setQuery($sql);
							$db->query();
						}

						JPluginHelper::importPlugin('system');
						$dispatcher->trigger('onAfterStoreSubscription', array(&$plan, &$model));

						EmeraldHelper::alertUser($res, $plan->alert_admin);
						$link = JRoute::_('index.php?option=com_emerald&view=plans&layout=history&plan=' . $sid . '&Itemid=' . (EM_HISTORY != '' ? EM_HISTORY : JRequest::getInt('Itemid')), false);
						$params = new JRegistry($plan->params);
						if ($params->get('redirect'))
						{
							$link = $params->get('redirect');
						}
						$payment['pay'] = 'success';
					}
					else
					{
						//error_log("\n[Not Stored ]: " . print_r($model->getErrors(), true), 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS . 'paypaypal' . DS . 'log.txt');
						$link = JRoute::_('index.php?option=com_emerald&view=plans&layout=history&Itemid=' . (EM_HISTORY != '' ? EM_HISTORY : JRequest::getInt('Itemid')), false);
						$msg = JText::_($model->getError(0));
					}
				}
				break;
			}
		}

		/*if(defined('EM_GAT_ENABLE') && defined('EM_GAT') && EM_GAT_ENABLE && EM_GAT != '' && $model->subscription_id)
		{
			$session = JFactory::getSession();
			$gat = array('gateway_id' => $res['gateway_id'], 'price' => $res['price'],
				'sid' => $model->subscription_id, 'status' => $res['pay'], 'name' => $plan->name);
			$session->set('gatracking-'.$res['user_id'], $gat);

			$config = JFactory::getConfig();

			$cookie_domain = $config->get('cookie_domain', '');
			$cookie_path = $config->get('cookie_path', '/');
			setcookie('gatracking-'.$res['user_id'], json_encode($gat), time() + 365 * 86400, $cookie_path, $cookie_domain);
		}*/

		$result = $dispatcher->trigger('onAfterReceivePayment', array( $param, $payment));
		var_dump($link);

		if ($link)
			$app->redirect($link, $msg);

		parent::display();

	}


	/*
	 function createCoupon()
	 {
		global $app;
		$row =& JTable::getInstance('subscr', 'Table');
		$row->value = '';
		$row->discount = '';
		$row->discount_type = 'sum';
		$row->use_user = 0;
		$row->use_num = 1;

		// Make sure the web link table is valid
		if (!$row->check()) {
		$this->setError($this->_db->getErrorMsg());
		return false;
		}


		// Store the web link table to the database
		if (!$row->store()) {
		if($return_fail = JRequest::getVar('return_fail'))
		{
		$app->redirect(base64_decode($return_fail));
		}
		}
		if($return_success = JRequest::getVar('return_success'))
		{
		$app->redirect(base64_decode($return_success));
		}

		}*/
}