<?php
/**
 * Emerald Restriction Plugin by MintJoomla
 * a plugin for Joomla! 1.7 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.menu');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

class plgSystemEmcomponent extends JPlugin
{

	var $_db = null;

	function plgSystemEmcomponent(& $subject, $config)
	{
		$this->_db = JFactory::getDBO();
		$this->app = JFactory::getApplication();
		parent::__construct($subject, $config);

		if($this->app->isAdmin()) return;
		$emerald_file = JPATH_ROOT . DS . 'components' . DS . 'com_emerald' . DS . 'emerald.php';
		if (!file_exists($emerald_file))
			return;

		require_once (JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_emerald' . DS . 'controllers' . DS . 'cnf.php');
		EmeraldControllerCnf::initialyze();

		require_once (JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_emerald' . DS . 'library' . DS . 'helper.php');
		require_once (JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_emerald' . DS . 'helpers' . DS . 'emerald.php');
	}

	function onAfterRoute()
	{
		if($this->app->isAdmin()) return;
		$emerald_file = JPATH_ROOT . DS . 'components' . DS . 'com_emerald' . DS . 'emerald.php';
		if (!file_exists($emerald_file))
			return;

		if (!defined('EM_GENERAL_EXPIRE_SEND'))
		{
			if ($this->params->get('alerts', 0))
				sendExpireAlerts($this->params);
		}
		else
		{
			if (EM_GENERAL_EXPIRE_SEND)
				sendExpireAlerts($this->params);
		}

		autoContentDelivery($this->params);

		trackingCodes();

		global $app, $query;

		if ($app->isAdmin())
			return;

		$plugin = JPluginHelper::getPlugin('system', 'emcomponent');
		//$cnf      = new JRegistry( $plugin->params );
		$db = JFactory::getDBO();
		$my = JFactory::getUser();
		$userid = $my->get('id');
		$view = JRequest::getVar('view');
		$session = JFactory::getSession();
		$option = JRequest::getVar('option');
		$prm = $app->getParams();



		if ($this->params->get('skip_for', 0) && in_array($this->params->get('skip_for'), $my->groups))
			return;
		if ($this->params->get('skip_author', 0) && ($option == 'com_resource' && JRequest::getString('controller') == 'article'))
		{
			$sql = "SELECT user_id FROM #__js_res_record WHERE id = '" . JRequest::getInt('article') . "'";
			$db->setQuery($sql);
			$author = $db->loadResult();
			if ($author == $userid)
				return;
		}

		$url = $session->get('em_access_url');
		$current = JURI::base() . str_replace("/", "", $_SERVER['REQUEST_URI']);

		if ($url == $current)
		{
			$session->clear('em_access_url');
		}

		if ($this->params->get('se', 1))
		{
			$bots = explode("\n", $this->params->get('bots'));
			foreach($bots as $bot)
			{
				if (!$bot)
					continue;
				if (@strpos($_SERVER['HTTP_USER_AGENT'], $bot) !== FALSE)
					return;
			}
		}

		if ($option == 'com_resource')
		{
			//echo "ssss"; exit;
			$query = "SELECT id, contentcategory as component, params, invisible  " . "\n FROM #__jcs_plans WHERE published = 1 AND `type_category` = 1 AND `contentcategory` != ''";
			$db->setQuery($query);
			$rows = $db->loadObjectList();
			$sid = array();

			if ($rows)
			{
				// GET LIST OF THE CATEGORIES RESTRICTED IN ALL PLANS
				$categories_to_restrict = emGetComponents($rows);

				//Get list of the categories that binded to currect article
				$record_categories[] = array();
				if (JRequest::getInt('article'))
				{
					$sql = "SELECT catid FROM #__js_res_record_category WHERE record_id = " . JRequest::getInt('article');
					$db->setQuery($sql);
					$record_categories = $db->loadResultArray();
				}
				if (JRequest::getInt('category_id') && !in_array(JRequest::getInt('category_id'), $record_categories))
					$record_categories[] = JRequest::getInt('category_id');

		// get list of the pluns restricting current categories.
				foreach($record_categories as $record_category)
				{
					foreach($rows as $row)
					{
						$catids = explode(",", $row->component);
						if (in_array($record_category, $catids)) // && !$row->invisible)
							$plans_active[$row->id] = $row->id;
					}
				}
				foreach($rows as $row)
				{
					$plan_params = new JRegistry($row->params);

					if ($plan_params->get('js_strict'))
					{
						if (in_array(JRequest::getInt('category_id'), $categories_to_restrict))
						{
							if (emCheckAccess($plans_active))
								break;
						}
					}
					else
					{
						if (JRequest::getInt('article'))
						{
							$break = false;
							foreach($record_categories as $record_category)
							{
								if (in_array($record_category, $categories_to_restrict))
								{
									if (emCheckAccess($plans_active))
									{
										$break = true;
										break;
									}
								}
							}
							if ($break)
								break;
						}
					}
				}
			}
		}

		$query = "SELECT id, component, params, invisible  " . "\n FROM #__jcs_plans WHERE published = 1 AND `type_component` = 1 AND `component` != ''";
		$db->setQuery($query);
		$rows = $db->loadObjectList();

		if (!$rows)
			return;

		$restrict_user = false;
		$plans_active = array();
		$components = emGetComponents($rows);

		/**
		 * if current component not in the list of all components that
		 * are under restriction of all plans, just return
		 */
		if (!@in_array($option, $components))
			return;

		/**
		 * if current component in the list of restricted components need
		 * to check parameters for every plan
		 */
		foreach($rows as $k => $row)
		{
			// If this plan is not for this component continue
			if (!preg_match("/" . $option . "/", $row->component))
				continue;

			$params = emGetParams($option, $row);

			if (!$params)
			{
				$restrict_user = true;
				$plans_active[$row->id] = $row->id;
				continue;
			}
			$task = emGetTask($params);
			$valarray = emGetValues($params);
			$conditions = emGetConditions($option, $row);

			//var_dump($conditions);
			//print_r($task);
			//print_r($valarray);
			//var_dump(TRUE && FALSE);


			if (@$task[0] && (@$task[0] != "novalsfound"))
			{
				if (!$valarray[0] && $conditions)
				{
					$restrict_user = true;
					$plans_active[$row->id] = $row->id;
					continue;
				}

				// if there is url key but value does not math do not count this plan
				if (in_array($task[0], $valarray[0]))
				{
					if (@$task[1] && (@$task[1] != "novalsfound"))
					{
						if (!$valarray[1] && $conditions)
						{
							$restrict_user = true;
							$plans_active[$row->id] = $row->id;
							continue;
						}

						if (in_array($task[1], $valarray[1]) && $conditions)
						{
							$restrict_user = true;
							$plans_active[$row->id] = $row->id;
							continue;
						}
					}
					else
					{
						//var_dump($conditions);
						if (!$conditions)
						{
							/*$restrict_user = true;
							 $plans_active[$row->id] = $row->id;*/
							continue;
						}
						else
						{
							$restrict_user = true;
							$plans_active[$row->id] = $row->id;
							continue;
						}
					}
				}
			}

			$params = emGetParams2($option, $row);

			if (!$params)
			{
				//$restrict_user = true;
				//$plans_active[$row->id] = $row->id;
				continue;
			}

			$task = emGetTask($params);
			$valarray = emGetValues($params);
			$conditions = emGetConditions($option, $row, 2);

			if (@$task[0] && (@$task[0] != "novalsfound"))
			{
				if (!$valarray[0] && $conditions)
				{
					$restrict_user = true;
					$plans_active[$row->id] = $row->id;
					continue;
				}

				// if there is url key but value does not math do not count this plan
				if (in_array($task[0], $valarray[0]))
				{
					if (@$task[1] && (@$task[1] != "novalsfound"))
					{
						if (!$valarray[1] && $conditions)
						{
							$restrict_user = true;
							$plans_active[$row->id] = $row->id;
							continue;
						}

						if (in_array($task[1], $valarray[1]) && $conditions)
						{
							$restrict_user = true;
							$plans_active[$row->id] = $row->id;
							continue;
						}
					}
					else
					{
						if (!$conditions)
						{
							/*$restrict_user = true;
							 $plans_active[$row->id] = $row->id;*/
							continue;
						}
						else
						{
							$restrict_user = true;
							$plans_active[$row->id] = $row->id;
							continue;
						}
					}
				}
			}
		}

		if ($restrict_user)
		{
			//print_r($plans_active);
			emCheckAccess($plans_active);
		}
	}
}

function emCheckAccess($plans)
{
	global $app;

	if (!$plans)
		return;

	$user = & JFactory::getUser();
	if (!$user->id)
	{
		emRedirectPurchase($plans);
		return;
	}
	$db = JFactory::getDBO();
	$uri = & JFactory::getURI();
	//$url = $db->getEscaped(stripslashes($uri->toString()));
	$url = $uri->toString();

	if (is_array($plans))
	{
		$plans = implode(',', $plans);
	}

	$sql = "SELECT u.subscription_id, s.params, u.id, s.`category`, u.access_count, u.access_limit
	FROM #__jcs_user_subscr AS u
	LEFT JOIN #__jcs_plans AS s ON s.id = u.subscription_id
	WHERE u.user_id = {$user->id}
	AND u.extime > NOW()
	AND u.ctime < NOW()
	AND u.published = 1
	AND u.subscription_id IN ({$plans})
	ORDER BY u.ctime DESC";

	$db->setQuery($sql);
	$res = $db->loadObjectList();

	if (!$res)
	{
		emRedirectPurchase($plans);
		return;
	}
	$restrict = false;

	foreach($res as $item)
	{
		$params = new JRegistry($item->params);
		if ($item->access_limit)
		{
			switch ($params->get('count_limit_mode'))
			{
				case 0 :
					emUpdateSubscription($item->id);
					return;
					break;

				case 1 :
					if ($item->access_count < $item->access_limit)
					{
						if (emCheckUrl($item->subscription_id))
							emUpdateSubscription($item->id);
						return;
					}

					else
					{
						$sql = "SELECT id FROM #__jcs_history
						WHERE user_id = '{$user->id}'
						AND url = '{$url}'
						AND subscription_id= {$item->subscription_id}";
						$db->setQuery($sql);
						if ($db->loadResult())
						{
							//emUpdateSubscription($item->id);
							return;
						}
					}
					break;

				case 2 :
					if ($item->access_count < $item->access_limit)
					{
						emUpdateSubscription($item->id);
						return true;
					}
					break;
			}
		}
		else
			return true;

	}

	emRedirectPurchase($plans);
}

function emCheckUrl($sid)
{
	$user = & JFactory::getUser();
	$db = JFactory::getDBO();
	$uri = & JFactory::getURI();
	$url = $db->getEscaped(stripslashes($uri->toString()));

	$sql = "SELECT id FROM #__jcs_history
	WHERE user_id = '{$user->id}'
	AND url = '{$url}'
	AND subscription_id= {$sid}";
	$db->setQuery($sql);
	if (!$db->loadResult())
	{
		$sql = "INSERT INTO #__jcs_history VALUES (NULL, '{$user->id}', '{$url}', NOW(), '{$sid}')";
		$db->setQuery($sql);
		$db->query();
		return true;
	}
	else
		return false;
}

function emRedirectPurchase($sid = false)
{

	global $app;

	$plans = $sid;
	if (is_array($sid))
		$sid = implode(",", $sid);
	$db = JFactory::getDBO();
	$sql = "SELECT id, invisible FROM #__jcs_plans WHERE id IN ( $sid )";
	$db->setQuery($sql);
	if ($res = $db->loadObjectList())
	{
		$ids = array();
		if (!is_array($plans))
			$plans = explode(',', $plans);
		if (!is_array($plans))
			settype($plans, 'array');
		foreach($res as $val)
		{
			if (in_array($val->id, $plans) && !$val->invisible)
			{
				$ids[] = $val->id;
			}
		}
		$sid = implode(',', $ids);
	}

	$Itemid = JRequest::getInt('Itemid');
	$session = & JFactory::getSession();
	if (EM_IID_PLANS)
		$Itemid = EM_IID_PLANS;

	$uri = JFactory::getURI();
	$url = $uri->toString();

	$session->set('em_access_url', $url);

	$link = "index.php?option=com_emerald&view=plans&layout=form&Itemid=" . $Itemid . ($sid ? "&id=" . $sid : "");
	$app->redirect(JRoute::_($link, false));
}

function emUpdateSubscription($id)
{
	$db = & JFactory::getDBO();
	$sql = "UPDATE #__jcs_user_subscr SET access_count = access_count + 1 WHERE id = {$id}";
	$db->setQuery($sql);
	$db->query();
}

function emGetConditions($option, $row, $level = 1)
{
	if (!defined('EM_MODE'))
		return true;
	if (!@EM_MODE)
		return true;

	$db = & JFactory::getDBO();
	//$dev_params = emGetDevParams($option, $row);
	//if(!$dev_params) return true;
	$params = new JRegistry($row->params);
	if (!$params->get($option . '_advtask' . $level) || $params->get($option . '_advval' . $level) == '')
		return true;

	if (strstr(JRequest::getVar($params->get($option . '_advtask' . $level), 'novalsfound'), ":"))
		$task = substr(JRequest::getVar($params->get($option . '_advtask' . $level), 'novalsfound'), 0, strpos(JRequest::getVar($params->get($option . '_advtask' . $level), 'novalsfound'), ":"));
	else
		$task = JRequest::getVar($params->get($option . '_advtask' . $level), 'novalsfound');

	if ($task == 'novalsfound')
		return false;

	$dev_params['task_name'] = $params->get($option . '_advtask' . $level);
	$dev_params['result'] = $task;
	$dev_params['values'] = explode(",", $params->get($option . '_advval' . $level));
	$dev_params['condition'] = $params->get($option . '_advcond' . $level);

	switch ($dev_params['condition'])
	{
		case '=' :
			{
				if (in_array($dev_params['result'], $dev_params['values']))
				{
					return true;
				}
				break;
			}
		case '!=' :
			{
				if (!in_array($dev_params['result'], $dev_params['values']))
				{
					return true;
				}
				break;
			}
		default :
			{
				$string = $db->getEscaped(stripslashes($dev_params['result']));

				if (strstr($dev_params['condition'], 'like'))
				{
					$condition = str_replace("(str)", $dev_params['values'][0], $dev_params['condition']);
					$sql = "SELECT IF( '{$string}' {$condition}, 1, 0)";
				}
				else
				{
					$condition = $dev_params['condition'];
					$string = (int)$string;
					$value = (int)$dev_params['values'][0];
					$sql = "SELECT IF( {$string} {$condition} {$value} , 1, 0)";
				}
				$db->setQuery($sql);
				if ($db->loadResult())
				{
					return true;
				}
			}
	}

	return false;
}

function emGetParams($option, $row)
{
	$out = false;
	$params = new JRegistry($row->params);

	if ($params->get($option . '_task1'))
	{
		$out[$params->get($option . '_task1')] = $params->get($option . '_val1');
	}
	if ($params->get($option . '_task2'))
	{
		$out[$params->get($option . '_task2')] = $params->get($option . '_val2');
	}
	return $out;
}

function emGetParams2($option, $row)
{
	$out = false;
	$params = new JRegistry($row->params);
	if ($params->get($option . '_task3'))
	{
		$out[$params->get($option . '_task3')] = $params->get($option . '_val3');
	}
	if ($params->get($option . '_task4'))
	{
		$out[$params->get($option . '_task4')] = $params->get($option . '_val4');
	}
	return $out;
}

function emGetTask($params)
{
	foreach($params as $var => $val)
	{
		if (strstr(JRequest::getVar($var, 'novalsfound'), ":"))
			$task[] = substr(JRequest::getVar($var, 'novalsfound'), 0, strpos(JRequest::getVar($var, 'novalsfound'), ":"));
		else
			$task[] = JRequest::getVar($var, 'novalsfound');
	}
	return $task;
}

function emGetValues($params)
{
	foreach($params as $var => $val)
	{
		$valarray[] = explode(",", $val);
	}
	return $valarray;
}

function emGetComponents($array)
{
	$restrict = array();
	if (count($array) > 0)
	{
		foreach($array as $arr)
		{
			if (!trim($arr->component))
				continue;
			$restrict = array_merge($restrict, explode(",", $arr->component));
		}
		$restrict = array_flip($restrict);
		$restrict = array_flip($restrict);
		return $restrict;
	}
	return $restrict;
}

function sendExpireAlerts($params)
{
	// requires INSTALL patch com_jcs.sql-patch.2.5.3.zip
	global $app;

	require_once (JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_emerald' . DS . 'controllers' . DS . 'cnf.php');
	jimport('joomla.filesystem.file');

	EmeraldControllerCnf::initialyze();

	if (EM_GENERAL_EXPIRE == '')
		return;
	$days = str_replace(' ', '', EM_GENERAL_EXPIRE);
	$days = explode(',', $days);

	rsort($days);

	$config = JFactory::getConfig();
	$db = Jfactory::getDBO();

	foreach($days as $key => $day)
	{
		$sql = "
		SELECT ru.email, ru.name as uname, ru.id as uid, u.id, u.gateway_id, u.user_id, p.name, p.params, p.alerts, a.id AS aid, a.sent
		FROM #__jcs_user_subscr AS u
		LEFT JOIN #__jcs_plans AS p ON p.id = u.subscription_id
		LEFT JOIN #__jcs_exp_alerts AS a ON a.user_subscription_id = u.id
		LEFT JOIN #__users AS ru ON ru.id = u.user_id
		WHERE u.extime < CURDATE() + INTERVAL " . $day . " DAY
		AND u.extime > NOW() ";
		if ($key == 0)
			$sql .= " AND  a.sent IS NULL ";
		else
			$sql .= " AND a.sent < " . ($key + 1);
		$sql .= " LIMIT 1 ";

		$db->setQuery($sql);
		$row = $db->loadObject();
		if (!$row)
			continue;

		if (is_object($row) && $row->sent < count($days))
		{
			$params = new JRegistry($row->params);
			$alerts = new JRegistry($row->alerts);
			if ($key == 0 && !$row->aid)
			{
				$sql = "INSERT INTO #__jcs_exp_alerts (`user_subscription_id`, `user_id`, `stime`, `sent`) VALUES ('{$row->id}', '{$row->uid}', NOW(), '1')";
			}
			if ($key > 0)
			{
				$sql = "UPDATE #__jcs_exp_alerts SET `sent` = `sent` + 1 WHERE user_subscription_id = '{$row->id}' AND user_id = '{$row->uid}'";
			}
			$db->setQuery($sql);
			$db->query();

			$subject = $alerts->get('msg_expiration_sbj', JText::_('Subscription expiration alert'));

			$lang = & JFactory::getLanguage();
			$lang->load('com_emerald');

			require_once (JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_emerald' . DS . 'controllers' . DS . 'cnf.php');
			EmeraldControllerCnf::initialyze();

			$body = $alerts->get('msg_expiration', JText::_('GENERAL_ALERT_EXPIRE'));

			$body = str_replace('[USER]', str_replace("\n", ' ', $row->uname), $body);
			$body = str_replace('[DAY]', $day, $body);
			//$body = str_replace('[DAY]', $params->get('day', 3), $body);
			$body = str_replace('[SUBSCR_NAME]', $row->name, $body);
			$body = str_replace('[SITE_NAME]', $app->getCfg('sitename'), $body);
			$body = str_replace('[ORDER_ID]', $row->gateway_id, $body);
			$body = str_replace('[SITE_URL]', JURI::root(), $body);

			if ($params->get('send_as', 'text') == 'text')
				$body = strip_tags(str_replace("<br />", "\n", $body));

			$mail = JFactory::getMailer();

			$sender[0] = $config->getValue('config.mailfrom');
			$sender[1] = $config->getValue('config.fromname');

			$mail->setSender($sender);
			$mail->AddAddress($row->email, str_replace("\n", ' ', $row->uname));
			$mail->setBody(JMailHelper::cleanBody($body));
			$mail->setSubject(JMailHelper::cleanSubject($subject));
			if (JString::strlen($body) != JString::strlen(strip_tags($body)))
			{
				$mail->IsHTML(true);
			}

			$mail->Send();
			if (defined('EM_ADMIN_EXPIRE_ALERT') && EM_ADMIN_EXPIRE_ALERT)
			{
				$subject = JText::_('Subscription expiration admin alert');

				$body = JText::_('GENERAL_ALERT_EXPIRE_ADMIN');
				$body = str_replace('[USER]', str_replace("\n", ' ', $row->uname), $body);
				$body = str_replace('[DAY]', $day, $body);
				//$body = str_replace('[DAY]', $params->get('day', 3), $body);
				$body = str_replace('[SUBSCR_NAME]', $row->name, $body);
				$body = str_replace('[SITE_NAME]', $app->getCfg('sitename'), $body);
				$body = str_replace('[ORDER_ID]', $row->gateway_id, $body);
				$body = str_replace('[SITE_URL]', JURI::root(), $body);

				$mail->ClearAllRecipients();

				$mail->setSender($sender);
				$mail->AddAddress($sender[0]);
				$mail->setBody(JMailHelper::cleanBody($body));
				$mail->setSubject(JMailHelper::cleanSubject($subject));
				if (JString::strlen($body) != JString::strlen(strip_tags($body)))
				{
					$mail->IsHTML(true);
				}

				$mail->Send();
			}
		}
	}
}

function autoContentDelivery($params)
{

	global $app;
	require_once (JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_emerald' . DS . 'controllers' . DS . 'cnf.php');
	jimport('joomla.filesystem.file');

	EmeraldControllerCnf::initialyze();

	$config = JFactory::getConfig();
	$db = Jfactory::getDBO();
	$sql = "SELECT u.*, p.alert_admin
    FROM #__jcs_user_subscr AS u
	LEFT JOIN #__jcs_plans AS p ON p.id = u.subscription_id
    WHERE u.ctime < NOW() AND u.extime > NOW() AND u.gateway = '.auto_content' AND u.published = '0'
    AND u.never_activated = '1'
    ORDER BY u.id
    LIMIT 1
    ";

	$db->setQuery($sql);
	$row = $db->loadObject();
	if (!$row)
		return;

	if (is_object($row))
	{

		$sql = "UPDATE #__jcs_user_subscr SET published = '1', never_activated = '0' WHERE id = '{$row->id}'";
		$db->setQuery($sql);
		$db->query();

		$res = array();
		$res['user_id'] = $row->user_id;
		$res['sid'] = $row->subscription_id;
		$res['published'] = $row->published;
		$res['pay'] = 'success';
		$res['gateway_id'] = $row->gateway_id;
		$res['price'] = $row->price;
		EmeraldHelper::alertUser($res, $row->alert_admin);
	}
}

function trackingCodes()
{
	$app = JFactory::getApplication();
	if($app->isAdmin()) return;
	$db = JFactory::getDBO();
	$user = JFactory::getUser();
	if (!$user->id)
		return;
		// ctime should be later than 1 July 2012 -  the date of this feature released
	$sql = "SELECT * FROM #__jcs_user_subscr WHERE user_id = '{$user->id}' AND tracking = '0' and published = '1' AND ctime > '2012-07-01 00:00:00'";
	$db->setQuery($sql);
	if ($rows = $db->loadObjectList())
	{
		$ids = array();
		foreach($rows as $row)
		{
			$tmp = 0;
			$ids[] = $row->id;
			if (defined('EM_GAT_ENABLE') && defined('EM_GAT') && EM_GAT_ENABLE && EM_GAT != '')
			{
			 	$sql = "SELECT p.name, c.title as cat FROM #__jcs_plans as p JOIN #__categories as c ON p.catid = c.id
				WHERE p.id = '{$row->subscription_id}'";
				$db->setQuery($sql);
				$plan = $db->loadObject();
				$js = "
				var _gaq = _gaq || [];
				  _gaq.push(['_setAccount', '" . EM_GAT . "']);
				  _gaq.push(['_trackPageview']);
				  _gaq.push(['_addTrans',
				    '".$row->gateway_id."',           // order ID - required
				    '".$app->getCfg('sitename')."',  // affiliation or store name
				    '".$row->price."',          // total - required
				    '',           // tax
				    '',              // shipping
				    '',       // city
				    '',     // state or province
				    ''             // country
				  ]);

				   // add item might be called for every item in the shopping cart
				   // where your ecommerce engine loops through each item in the cart and
				   // prints out _addItem for each
				  _gaq.push(['_addItem',
				    '".$row->gateway_id."',           // order ID - required
				    '".$row->id."',           // SKU/code - required
				    '".$plan->name."',        // product name
				    '".$plan->cat."',   // category or variation
				    '".$row->price."',          // unit price - required
				    '1'               // quantity - required
				  ]);
				  _gaq.push(['_trackTrans']); //submits transaction to the Analytics servers

				  (function() {
				    var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
				    ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
				    var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
				  })();
				";
				JFactory::getDocument()->addScriptDeclaration($js);
				$tmp ++;
			}

			if(extension_loaded('curl') && (EM_IDEV || EM_AMIGOS ))
			{
				if(EM_IDEV)
				{
					$ch = curl_init();
					curl_setopt($ch, CURLOPT_URL, EM_IDEV."/sale.php?profile=72198&idev_saleamt={$row->price}&idev_ordernum={$row->id}&ip_address=".getenv('REMOTE_ADDR'));
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					curl_exec($ch);
					curl_close($ch);
					$tmp ++;
				}
				if(EM_AMIGOS)
				{
					$ch = curl_init();
					// amigosid should be received from cookie
					curl_setopt($ch, CURLOPT_URL, EM_AMIGOS."/index.php?option=com_amigos&task=sale&amigos_id=".JRequest::getVar('amigosid')."&amigos_ordertype=Emerald&amigos_orderid={$row->id}&amigos_orderamount={$row->price}&amigos_ipaddress=".getenv('REMOTE_ADDR'));
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					curl_exec($ch);
					curl_close($ch);
					$tmp ++;
				}
			}
			else
			{
				if(!extension_loaded('curl'))JError::raiseNotice(100, JText::_('PHP extension CURL not loaded. Fail iDev integration.'));
			}
		}

		$query = "UPDATE #__jcs_user_subscr SET tracking = '1' WHERE id IN (".implode(', ', $ids).")";
		$db->setQuery($query);
		$db->query();

		JFactory::getLanguage()->load('com_emerald', JPATH_ROOT);

		$msg = str_replace('[LINK]', JHtml::link('index.php?option=com_emerald&view=plans&layout=history&Itemid='.JRequest::getInt('Itemid'), JText::_('link')), JText::_('EM_SUBSCR_CREATED'));
		$app->enqueueMessage($msg);

// 		JError::raiseWarning(100, $msg);
	}
}

?>