<?php
/**
 * Emerald Payment Plugin by MintJoomla
 * a plugin for Joomla! 1.7 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.menu');

class plgEmeraldPayoffline extends JPlugin
{

	var $_db = null;
	function plgEmeraldPayoffline(& $subject, $config)
	{
		$this->_db = JFactory :: getDBO();
		parent :: __construct($subject, $config);
	}
	function onReceivePayment(&$post)
	{
		global $app;

		if($app->isAdmin()) return;
		if($post['processor'] != 'payoffline') return 0;
		$user = JFactory::getUser();
		$db =  JFactory::getDBO();


		$params = new JRegistry($post['params']);
		$default = $this->params;

		$out['sid'] = $post['order_id'];
		$out['gateway'] = $post['gateway'];
		$out['gateway_id'] = $post['gateway_id'];
		$out['user_id'] = @$post['user_id'] ? $post['user_id'] : $user->get('id');
		$out['price'] = $post['order_amount'];
		$out['pay'] = $post['order_amount'] > 0 ? 'fail' : 'success';

		//if($default->get('payoffline_published', 0))
		if($params->get('params.payoffline_published', 0))
		{
			$out['pay'] = 'success';
		}

		if($post['order_amount'] == 0)
		{
			$out['pay']    = 'success';
		}
		if(class_exists('Bill')) $out['key']  = strtoupper(md5(Bill::getSecretWord().$out['user_id'].$post['gateway_id'].$out['price'].$out['sid']));

		$config = JFactory::getConfig();
		$user = JFactory::getUser();

		$subject = $params->get('params.payoffline_cus_subj', $default->get('payoffline_cus_subj'));

		$session = JFactory::getSession();
		$reg = $session->get('registry');

		jimport('joomla.mail.mail');
		jimport('joomla.mail.helper');


		$sender[0] = $config->getValue('config.mailfrom');
		$sender[1] = $config->getValue('config.fromname');

		//if(!$default->get('payoffline_published', 0))
		if(!$params->get('params.payoffline_published', 0))
		{
			$body = $params->get('params.payoffline_cus_body', $default->get('payoffline_cus_body'));

			$body = str_replace('[USER]', $user->get('name'),$body);
			$body = str_replace('[FIRST_NAME]', $user->get('name'),$body);
			$body = str_replace('[SUBSCR_NAME]', $post['order_title'], $body);
			$body = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $body);
			$body = str_replace('[ORDER_ID]', $post['gateway_id'], $body);

			require_once (JPATH_ADMINISTRATOR.DS.'components'.DS.'com_emerald'.DS.'controllers'.DS.'cnf.php');
			EmeraldControllerCnf::initialyze();

			$body = str_replace('[PRICE]', str_replace(array("00", "Sign") , array($post['order_amount'], EM_GENERAL_CURR), EM_LAYOUT_PRICE), $body);

			$mail = JFactory::getMailer();

			if ( JString::strlen($body) != JString::strlen(strip_tags($body)))
			$mail->IsHTML(true);

			$mail->setSender($sender);
			$mail->AddAddress($user->get('email'));
			$mail->setBody(JMailHelper::cleanBody($body));
			$mail->setSubject(JMailHelper::cleanSubject($subject));



			if(!$mail->Send())
			{
				JError::raiseWarning(200, 'Error to send user alert');
			}
		}
		$subject = $params->get('params.payoffline_subject', $default->get('payoffline_subject'));


		$body = $params->get('params.payoffline_published', 0) ? JText::_("SUCCESS_OFFLINE_ADMIN_ALERT") : JText::_("OFFLINE_ADMIN_ALERT");
		//$body = $default->get('payoffline_published', 0) ? JText::_("SUCCESS_OFFLINE_ADMIN_ALERT") : JText::_("OFFLINE_ADMIN_ALERT");
		$body = str_replace('[USER]', $user->get('name'),$body);
		$body = str_replace('[FIRST_NAME]', $user->get('name'),$body);
		$body = str_replace('[NAME]', $user->get('name'),$body);
		$body = str_replace('[EMAIL]', $user->get('email'),$body);
		$body = str_replace('[SUBSCR_NAME]', $post['order_title'], $body);
		$body = str_replace('[ORDER_ID]', $post['gateway_id'], $body);
		$body = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $body);
		$body = str_replace('[SITE_URL]', JURI::root(), $body);


		$mail = JFactory::getMailer();
		$mail->setSender($sender);

		$recipient = $params->get('params.payoffline_email', $default->get('payoffline_email')) ? $params->get('params.payoffline_email', $default->get('payoffline_email')) : $config->getValue('config.mailfrom');
		$recipient = str_replace(", ", ",", $recipient);
		$recipient = explode(",", $recipient);
		$mail->ClearAllRecipients();
		$mail->addRecipient($recipient);

		//$mail->AddAddress($params->get('params.payoffline_email', $default->get('payoffline_email')) ? $params->get('params.payoffline_email', $default->get('payoffline_email')) : $config->getValue('config.mailfrom'));
		$mail->setBody(JMailHelper::cleanBody($body));
		$mail->setSubject(JMailHelper::cleanSubject($subject));
		if ( JString::strlen($body) != JString::strlen(strip_tags($body)))
		$mail->IsHTML(true);

		if(!$mail->Send())
		{
			JError::raiseWarning(200, 'Error to send admin alert');
		}

		return $out;
	}
	function onSendPayment(&$post)
	{
		global $app;
		if($app->isAdmin()) return;

		if($post['processor'] != 'payoffline') return false;

		$user   = JFactory::getUser();
		$param['processor'] = $post['processor'];
		$param['option'] = JRequest::getCmd('option');
		$param['email']  = $user->get('email');
		$param['task']   = $post['task'];
		$param['view']   = $post['view'];
		$param['layout'] = $post['layout'];
		$param['pay']    = 'fail';
		$param['gateway']  = $post['processor'];
		$param['gateway_id'] = time();
		$param['order_amount'] = $post['order_amount'];
		$param['order_title'] = $post['order_title'];
		$param['order_id'] =$post['order_id'];
		if( isset( $post['Itemid'] ) ) {
			$param['Itemid']       = $post['Itemid'];
		}

		$this->deleteUnactiveSubscr();

		if(!isset($param['order_amount']) || !$user->get('id') || !$param['processor'] || !$param['order_id'])
		{
			$app->enqueueMessage('Some of the required information is missed for completing transaction<br>');
			return;
		}

		$url = 'index.php?'.$this->mmArray2Url($param);

		$app->redirect($url);
	}

	function onCheckParams($params)
	{
		$db = JFactory::getDBO();
		$sql = "SELECT name FROM #__extensions WHERE folder = 'emerald' AND element = 'payoffline' AND type='plugin'";
		$db->setQuery($sql);
		$title = $db->loadResult();
		if($params->get('params.payoffline_cus_body') == '')
		JError::raiseNotice(100, $title.': '.JText::_('Customer Email Alert is not set'));
	}

	function mmArray2Url($post)
	{
		foreach($post AS $k => $v)
		{
			$out[] = "$k=$v";
		}
		return implode('&', $out );
	}

	function deleteUnactiveSubscr()
	{
		$sql = "SELECT p.id, p.params, p.name AS subscr FROM #__jcs_user_subscr AS s
		LEFT JOIN #__jcs_plans AS p ON s.subscription_id=p.id
		LEFT JOIN #__users AS u ON s.user_id=u.id
		WHERE s.gateway = 'payoffline'
		GROUP BY p.name";// AND p.published='1'";
		$this->_db->setQuery( $sql );
		$plans = $this->_db->loadObjectList();
		jimport('joomla.mail.mail');
		jimport('joomla.mail.helper');
		$config = JFactory::getConfig();
		$sender[0] = $config->getValue('config.mailfrom');
		$sender[1] = $config->getValue('config.fromname');

		foreach( $plans as $sub)
		{
			$params = new JRegistry($sub->params);
			$time_limit = $params->get('params.payoffline_time_limit', '');
			if($time_limit != ''){

				$sql = "SELECT u.email FROM #__jcs_user_subscr AS s
				LEFT JOIN #__users AS u ON s.user_id=u.id
				WHERE s.published = '0' AND s.ctime + INTERVAL {$time_limit} DAY < NOW()
				AND subscription_id = '".$sub->id."'
				GROUP BY u.email";
				$this->_db->setQuery( $sql );
				$emails = $this->_db->loadResultArray();
				if(count($emails) > 0)
				{
					$sql = "DELETE FROM #__jcs_user_subscr
					WHERE published = '0' AND ctime + INTERVAL {$time_limit} DAY < NOW()
					AND subscription_id = '".$sub->id."'";
					$this->_db->setQuery( $sql );
					$this->_db->query();

					if($params->get('params.payoffline_time_limit_alert', 1))
					{

						$body = JText::_("GENERAL_ALERT_TIME_LIMIT");

						$body = str_replace('[SUBSCR_NAME]', $sub->subscr, $body);
						$body = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $body);
						$body = str_replace('[SITE_URL]', JURI::root(), $body);

						$subject = JText::_("GENERAL_ALERT_TIME_LIMIT_SUBJ");
						$subject = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $subject);

						$mail = JFactory::getMailer();

						$mail->setSender($sender);
						//$mail->addRecipient($emails);
						$mail->addBCC($emails);
						$mail->setBody(JMailHelper::cleanBody($body));
						$mail->setSubject(JMailHelper::cleanSubject($subject));
						if ( JString::strlen($body) != JString::strlen(strip_tags($body)))
						$mail->IsHTML(true);
						$mail->Send();
					}
				}
			}
		}
	}
}
?>